module: naming-protocol

define constant CosNaming/<Istring> = CORBA/<string>;

define sealed class CosNaming/<NameComponent> (CORBA/<struct>)
  slot CosNaming/NameComponent/id :: CosNaming/<Istring>, required-init-keyword: id:;
  slot CosNaming/NameComponent/kind :: CosNaming/<Istring>, required-init-keyword: kind:;
end class;
define sealed domain make (singleton(CosNaming/<NameComponent>));
define sealed domain initialize (CosNaming/<NameComponent>);

define constant CosNaming/$NameComponent-typecode = make(<struct-typecode>, type: CosNaming/<NameComponent>, name: "NameComponent", repository-id: "IDL:omg.org/CosNaming/NameComponent:1.0", members: vector(make(<typecode-member>, name: "id", type: CosNaming/<Istring>, getter: CosNaming/NameComponent/id, setter: CosNaming/NameComponent/id-setter, init-keyword: id:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "kind", type: CosNaming/<Istring>, getter: CosNaming/NameComponent/kind, setter: CosNaming/NameComponent/kind-setter, init-keyword: kind:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0))));

define method class-typecode (class == CosNaming/<NameComponent>)
 => (typecode :: <struct-typecode>)
  CosNaming/$NameComponent-typecode;
end method;

define method object-typecode (object :: CosNaming/<NameComponent>)
 => (typecode :: <struct-typecode>)
  CosNaming/$NameComponent-typecode;
end method;

define constant CosNaming/<Name> = limited(CORBA/<sequence>, of: CosNaming/<NameComponent>);

define constant CosNaming/<BindingType> = one-of(#"nobject", #"ncontext");

define generic CosNaming/BindingType/successor (symbol :: CosNaming/<BindingType>)
 => (succ :: CosNaming/<BindingType>);

define generic CosNaming/BindingType/predecessor (symbol :: CosNaming/<BindingType>)
 => (pred :: CosNaming/<BindingType>);

define generic CosNaming/BindingType/< (lesser :: CosNaming/<BindingType>, greater :: CosNaming/<BindingType>)
 => (lesser? :: <boolean>);

define generic CosNaming/BindingType/> (greater :: CosNaming/<BindingType>, lesser :: CosNaming/<BindingType>)
 => (greater? :: <boolean>);

define constant CosNaming/$BindingType-typecode = make(<enum-typecode>, type: CosNaming/<BindingType>, name: "BindingType", repository-id: "IDL:omg.org/CosNaming/BindingType:1.0", members: vector(#"nobject", #"ncontext"));

define method class-typecode (class == CosNaming/<BindingType>)
 => (typecode :: <enum-typecode>)
  CosNaming/$BindingType-typecode;
end method;

define sideways method object-typecode (object :: CosNaming/<BindingType>)
 => (typecode :: <enum-typecode>)
  CosNaming/$BindingType-typecode;
end method;

define inline-only function CosNaming/BindingType/as-symbol (integer :: <integer>)
 => (symbol :: CosNaming/<BindingType>)
  let typecode = class-typecode(CosNaming/<BindingType>);
  typecode-members(typecode)[integer];
end function;

define inline-only function CosNaming/BindingType/as-integer (symbol :: CosNaming/<BindingType>)
 => (integer :: <integer>)
  let typecode = class-typecode(CosNaming/<BindingType>);
  typecode-symbol-index(typecode)[symbol];
end function;

define method CosNaming/BindingType/successor (symbol :: CosNaming/<BindingType>)
 => (succ :: CosNaming/<BindingType>)
  let i = CosNaming/BindingType/as-integer(symbol);
  CosNaming/BindingType/as-symbol(modulo(i + 1, 2));
end method;

define method CosNaming/BindingType/predecessor (symbol :: CosNaming/<BindingType>)
 => (pred :: CosNaming/<BindingType>)
  let i = CosNaming/BindingType/as-integer(symbol);
  CosNaming/BindingType/as-symbol(modulo(2 + i - 1, 2));
end method;

define method CosNaming/BindingType/< (lesser :: CosNaming/<BindingType>, greater :: CosNaming/<BindingType>)
 => (lesser? :: <boolean>)
  CosNaming/BindingType/as-integer(lesser) < CosNaming/BindingType/as-integer(greater);
end method;

define method CosNaming/BindingType/> (greater :: CosNaming/<BindingType>, lesser :: CosNaming/<BindingType>)
 => (greater? :: <boolean>)
  CosNaming/BindingType/as-integer(greater) > CosNaming/BindingType/as-integer(lesser);
end method;

define sealed class CosNaming/<Binding> (CORBA/<struct>)
  slot CosNaming/Binding/binding-name :: CosNaming/<Name>, required-init-keyword: binding-name:;
  slot CosNaming/Binding/binding-type :: CosNaming/<BindingType>, required-init-keyword: binding-type:;
end class;
define sealed domain make (singleton(CosNaming/<Binding>));
define sealed domain initialize (CosNaming/<Binding>);

define constant CosNaming/$Binding-typecode = make(<struct-typecode>, type: CosNaming/<Binding>, name: "Binding", repository-id: "IDL:omg.org/CosNaming/Binding:1.0", members: vector(make(<typecode-member>, name: "binding_name", type: CosNaming/<Name>, getter: CosNaming/Binding/binding-name, setter: CosNaming/Binding/binding-name-setter, init-keyword: binding-name:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), max-length: 0, element-typecode: class-typecode(CosNaming/<NameComponent>))), make(<typecode-member>, name: "binding_type", type: CosNaming/<BindingType>, getter: CosNaming/Binding/binding-type, setter: CosNaming/Binding/binding-type-setter, init-keyword: binding-type:, typecode: class-typecode(CosNaming/<BindingType>))));

define method class-typecode (class == CosNaming/<Binding>)
 => (typecode :: <struct-typecode>)
  CosNaming/$Binding-typecode;
end method;

define method object-typecode (object :: CosNaming/<Binding>)
 => (typecode :: <struct-typecode>)
  CosNaming/$Binding-typecode;
end method;

define constant CosNaming/<BindingList> = limited(CORBA/<sequence>, of: CosNaming/<Binding>);

define constant CosNaming/$BindingIterator-typecode = make(<object-reference-typecode>, type: CosNaming/<BindingIterator>, name: "BindingIterator", repository-id: "IDL:omg.org/CosNaming/BindingIterator:1.0");

define open abstract class CosNaming/<BindingIterator> (<object>)
end class;

define method class-typecode (class :: subclass(CosNaming/<BindingIterator>))
 => (typecode :: <object-reference-typecode>)
  CosNaming/$BindingIterator-typecode;
end method;

define method object-typecode (object :: CosNaming/<BindingIterator>)
 => (typecode :: <object-reference-typecode>)
  CosNaming/$BindingIterator-typecode;
end method;

define open abstract class CosNaming/<NamingContext> (<object>)
end class;

define method class-typecode (class :: subclass(CosNaming/<NamingContext>))
 => (typecode :: <object-reference-typecode>)
  CosNaming/$NamingContext-typecode;
end method;

define method object-typecode (object :: CosNaming/<NamingContext>)
 => (typecode :: <object-reference-typecode>)
  CosNaming/$NamingContext-typecode;
end method;

define constant CosNaming/$NamingContext-typecode = make(<object-reference-typecode>, type: CosNaming/<NamingContext>, name: "NamingContext", repository-id: "IDL:omg.org/CosNaming/NamingContext:1.0");

define constant CosNaming/NamingContext/<NotFoundReason> = one-of(#"missing-node", #"not-context", #"not-object");

define generic CosNaming/NamingContext/NotFoundReason/successor (symbol :: CosNaming/NamingContext/<NotFoundReason>)
 => (succ :: CosNaming/NamingContext/<NotFoundReason>);

define generic CosNaming/NamingContext/NotFoundReason/predecessor (symbol :: CosNaming/NamingContext/<NotFoundReason>)
 => (pred :: CosNaming/NamingContext/<NotFoundReason>);

define generic CosNaming/NamingContext/NotFoundReason/< (lesser :: CosNaming/NamingContext/<NotFoundReason>, greater :: CosNaming/NamingContext/<NotFoundReason>)
 => (lesser? :: <boolean>);

define generic CosNaming/NamingContext/NotFoundReason/> (greater :: CosNaming/NamingContext/<NotFoundReason>, lesser :: CosNaming/NamingContext/<NotFoundReason>)
 => (greater? :: <boolean>);

define constant CosNaming/NamingContext/$NotFoundReason-typecode = make(<enum-typecode>, type: CosNaming/NamingContext/<NotFoundReason>, name: "NotFoundReason", repository-id: "IDL:omg.org/CosNaming/NamingContext/NotFoundReason:1.0", members: vector(#"missing-node", #"not-context", #"not-object"));

define method class-typecode (class == CosNaming/NamingContext/<NotFoundReason>)
 => (typecode :: <enum-typecode>)
  CosNaming/NamingContext/$NotFoundReason-typecode;
end method;

define sideways method object-typecode (object :: CosNaming/NamingContext/<NotFoundReason>)
 => (typecode :: <enum-typecode>)
  CosNaming/NamingContext/$NotFoundReason-typecode;
end method;

define inline-only function CosNaming/NamingContext/NotFoundReason/as-symbol (integer :: <integer>)
 => (symbol :: CosNaming/NamingContext/<NotFoundReason>)
  let typecode = class-typecode(CosNaming/NamingContext/<NotFoundReason>);
  typecode-members(typecode)[integer];
end function;

define inline-only function CosNaming/NamingContext/NotFoundReason/as-integer (symbol :: CosNaming/NamingContext/<NotFoundReason>)
 => (integer :: <integer>)
  let typecode = class-typecode(CosNaming/NamingContext/<NotFoundReason>);
  typecode-symbol-index(typecode)[symbol];
end function;

define method CosNaming/NamingContext/NotFoundReason/successor (symbol :: CosNaming/NamingContext/<NotFoundReason>)
 => (succ :: CosNaming/NamingContext/<NotFoundReason>)
  let i = CosNaming/NamingContext/NotFoundReason/as-integer(symbol);
  CosNaming/NamingContext/NotFoundReason/as-symbol(modulo(i + 1, 3));
end method;

define method CosNaming/NamingContext/NotFoundReason/predecessor (symbol :: CosNaming/NamingContext/<NotFoundReason>)
 => (pred :: CosNaming/NamingContext/<NotFoundReason>)
  let i = CosNaming/NamingContext/NotFoundReason/as-integer(symbol);
  CosNaming/NamingContext/NotFoundReason/as-symbol(modulo(3 + i - 1, 3));
end method;

define method CosNaming/NamingContext/NotFoundReason/< (lesser :: CosNaming/NamingContext/<NotFoundReason>, greater :: CosNaming/NamingContext/<NotFoundReason>)
 => (lesser? :: <boolean>)
  CosNaming/NamingContext/NotFoundReason/as-integer(lesser) < CosNaming/NamingContext/NotFoundReason/as-integer(greater);
end method;

define method CosNaming/NamingContext/NotFoundReason/> (greater :: CosNaming/NamingContext/<NotFoundReason>, lesser :: CosNaming/NamingContext/<NotFoundReason>)
 => (greater? :: <boolean>)
  CosNaming/NamingContext/NotFoundReason/as-integer(greater) > CosNaming/NamingContext/NotFoundReason/as-integer(lesser);
end method;

define sealed class CosNaming/NamingContext/<NotFound> (CORBA/<user-exception>)
  slot CosNaming/NamingContext/NotFound/why :: CosNaming/NamingContext/<NotFoundReason>, required-init-keyword: why:;
  slot CosNaming/NamingContext/NotFound/rest-of-name :: CosNaming/<Name>, required-init-keyword: rest-of-name:;
end class;
define sealed domain make (singleton(CosNaming/NamingContext/<NotFound>));
define sealed domain initialize (CosNaming/NamingContext/<NotFound>);

define constant CosNaming/NamingContext/$NotFound-typecode = make(<exception-typecode>, type: CosNaming/NamingContext/<NotFound>, name: "NotFound", repository-id: "IDL:omg.org/CosNaming/NamingContext/NotFound:1.0", members: vector(make(<typecode-member>, name: "why", type: CosNaming/NamingContext/<NotFoundReason>, getter: CosNaming/NamingContext/NotFound/why, setter: CosNaming/NamingContext/NotFound/why-setter, init-keyword: why:, typecode: class-typecode(CosNaming/NamingContext/<NotFoundReason>)), make(<typecode-member>, name: "rest_of_name", type: CosNaming/<Name>, getter: CosNaming/NamingContext/NotFound/rest-of-name, setter: CosNaming/NamingContext/NotFound/rest-of-name-setter, init-keyword: rest-of-name:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), max-length: 0, element-typecode: class-typecode(CosNaming/<NameComponent>)))));

define method class-typecode (class == CosNaming/NamingContext/<NotFound>)
 => (typecode :: <struct-typecode>)
  CosNaming/NamingContext/$NotFound-typecode;
end method;

define method object-typecode (object :: CosNaming/NamingContext/<NotFound>)
 => (typecode :: <struct-typecode>)
  CosNaming/NamingContext/$NotFound-typecode;
end method;

define sealed class CosNaming/NamingContext/<CannotProceed> (CORBA/<user-exception>)
  slot CosNaming/NamingContext/CannotProceed/cxt :: CosNaming/<NamingContext>, required-init-keyword: cxt:;
  slot CosNaming/NamingContext/CannotProceed/rest-of-name :: CosNaming/<Name>, required-init-keyword: rest-of-name:;
end class;
define sealed domain make (singleton(CosNaming/NamingContext/<CannotProceed>));
define sealed domain initialize (CosNaming/NamingContext/<CannotProceed>);

define constant CosNaming/NamingContext/$CannotProceed-typecode = make(<exception-typecode>, type: CosNaming/NamingContext/<CannotProceed>, name: "CannotProceed", repository-id: "IDL:omg.org/CosNaming/NamingContext/CannotProceed:1.0", members: vector(make(<typecode-member>, name: "cxt", type: CosNaming/<NamingContext>, getter: CosNaming/NamingContext/CannotProceed/cxt, setter: CosNaming/NamingContext/CannotProceed/cxt-setter, init-keyword: cxt:, typecode: class-typecode(CosNaming/<NamingContext>)), make(<typecode-member>, name: "rest_of_name", type: CosNaming/<Name>, getter: CosNaming/NamingContext/CannotProceed/rest-of-name, setter: CosNaming/NamingContext/CannotProceed/rest-of-name-setter, init-keyword: rest-of-name:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), max-length: 0, element-typecode: class-typecode(CosNaming/<NameComponent>)))));

define method class-typecode (class == CosNaming/NamingContext/<CannotProceed>)
 => (typecode :: <struct-typecode>)
  CosNaming/NamingContext/$CannotProceed-typecode;
end method;

define method object-typecode (object :: CosNaming/NamingContext/<CannotProceed>)
 => (typecode :: <struct-typecode>)
  CosNaming/NamingContext/$CannotProceed-typecode;
end method;

define sealed class CosNaming/NamingContext/<InvalidName> (CORBA/<user-exception>)
end class;
define sealed domain make (singleton(CosNaming/NamingContext/<InvalidName>));
define sealed domain initialize (CosNaming/NamingContext/<InvalidName>);

define constant CosNaming/NamingContext/$InvalidName-typecode = make(<exception-typecode>, type: CosNaming/NamingContext/<InvalidName>, name: "InvalidName", repository-id: "IDL:omg.org/CosNaming/NamingContext/InvalidName:1.0", members: vector());

define method class-typecode (class == CosNaming/NamingContext/<InvalidName>)
 => (typecode :: <struct-typecode>)
  CosNaming/NamingContext/$InvalidName-typecode;
end method;

define method object-typecode (object :: CosNaming/NamingContext/<InvalidName>)
 => (typecode :: <struct-typecode>)
  CosNaming/NamingContext/$InvalidName-typecode;
end method;

define sealed class CosNaming/NamingContext/<AlreadyBound> (CORBA/<user-exception>)
end class;
define sealed domain make (singleton(CosNaming/NamingContext/<AlreadyBound>));
define sealed domain initialize (CosNaming/NamingContext/<AlreadyBound>);

define constant CosNaming/NamingContext/$AlreadyBound-typecode = make(<exception-typecode>, type: CosNaming/NamingContext/<AlreadyBound>, name: "AlreadyBound", repository-id: "IDL:omg.org/CosNaming/NamingContext/AlreadyBound:1.0", members: vector());

define method class-typecode (class == CosNaming/NamingContext/<AlreadyBound>)
 => (typecode :: <struct-typecode>)
  CosNaming/NamingContext/$AlreadyBound-typecode;
end method;

define method object-typecode (object :: CosNaming/NamingContext/<AlreadyBound>)
 => (typecode :: <struct-typecode>)
  CosNaming/NamingContext/$AlreadyBound-typecode;
end method;

define sealed class CosNaming/NamingContext/<NotEmpty> (CORBA/<user-exception>)
end class;
define sealed domain make (singleton(CosNaming/NamingContext/<NotEmpty>));
define sealed domain initialize (CosNaming/NamingContext/<NotEmpty>);

define constant CosNaming/NamingContext/$NotEmpty-typecode = make(<exception-typecode>, type: CosNaming/NamingContext/<NotEmpty>, name: "NotEmpty", repository-id: "IDL:omg.org/CosNaming/NamingContext/NotEmpty:1.0", members: vector());

define method class-typecode (class == CosNaming/NamingContext/<NotEmpty>)
 => (typecode :: <struct-typecode>)
  CosNaming/NamingContext/$NotEmpty-typecode;
end method;

define method object-typecode (object :: CosNaming/NamingContext/<NotEmpty>)
 => (typecode :: <struct-typecode>)
  CosNaming/NamingContext/$NotEmpty-typecode;
end method;

define open generic CosNaming/NamingContext/bind (object :: CosNaming/<NamingContext>, n :: CosNaming/<Name>, obj :: CORBA/<Object>)
 => ();

define open generic CosNaming/NamingContext/rebind (object :: CosNaming/<NamingContext>, n :: CosNaming/<Name>, obj :: CORBA/<Object>)
 => ();

define open generic CosNaming/NamingContext/bind-context (object :: CosNaming/<NamingContext>, n :: CosNaming/<Name>, nc :: CosNaming/<NamingContext>)
 => ();

define open generic CosNaming/NamingContext/rebind-context (object :: CosNaming/<NamingContext>, n :: CosNaming/<Name>, nc :: CosNaming/<NamingContext>)
 => ();

define open generic CosNaming/NamingContext/resolve (object :: CosNaming/<NamingContext>, n :: CosNaming/<Name>)
 => (result :: CORBA/<Object>);

define open generic CosNaming/NamingContext/unbind (object :: CosNaming/<NamingContext>, n :: CosNaming/<Name>)
 => ();

define open generic CosNaming/NamingContext/new-context (object :: CosNaming/<NamingContext>)
 => (result :: CosNaming/<NamingContext>);

define open generic CosNaming/NamingContext/bind-new-context (object :: CosNaming/<NamingContext>, n :: CosNaming/<Name>)
 => (result :: CosNaming/<NamingContext>);

define open generic CosNaming/NamingContext/destroy (object :: CosNaming/<NamingContext>)
 => ();

define open generic CosNaming/NamingContext/list (object :: CosNaming/<NamingContext>, how-many :: CORBA/<unsigned-long>)
 => (bl :: CosNaming/<BindingList>, bi :: CosNaming/<BindingIterator>);

define open generic CosNaming/BindingIterator/next-one (object :: CosNaming/<BindingIterator>)
 => (result :: CORBA/<boolean>, b :: CosNaming/<Binding>);

define open generic CosNaming/BindingIterator/next-n (object :: CosNaming/<BindingIterator>, how-many :: CORBA/<unsigned-long>)
 => (result :: CORBA/<boolean>, bl :: CosNaming/<BindingList>);

define open generic CosNaming/BindingIterator/destroy (object :: CosNaming/<BindingIterator>)
 => ();


/* eof */
