module: naming-skeletons

define open abstract class CosNaming/<BindingIterator-servant> (CosNaming/<BindingIterator>, PortableServer/<servant>)
end class;

define open abstract class CosNaming/<NamingContext-servant> (CosNaming/<NamingContext>, PortableServer/<servant>)
end class;

define method invoke-operation (object :: CosNaming/<NamingContext-servant>, request :: CORBA/<ServerRequest>, operation == #"bind")
 => ()
  let arguments = make(CORBA/<NVList>);
  let n = make(CORBA/<NamedValue>, name: "n", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), max-length: 0, element-typecode: class-typecode(CosNaming/<NameComponent>))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, n);
  let obj = make(CORBA/<NamedValue>, name: "obj", argument: make(CORBA/<any>, type: class-typecode(<object-reference>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, obj);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/NamingContext/bind(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
end method;

define method invoke-operation (object :: CosNaming/<NamingContext-servant>, request :: CORBA/<ServerRequest>, operation == #"rebind")
 => ()
  let arguments = make(CORBA/<NVList>);
  let n = make(CORBA/<NamedValue>, name: "n", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), max-length: 0, element-typecode: class-typecode(CosNaming/<NameComponent>))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, n);
  let obj = make(CORBA/<NamedValue>, name: "obj", argument: make(CORBA/<any>, type: class-typecode(<object-reference>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, obj);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/NamingContext/rebind(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), CORBA/any/value(CORBA/NamedValue/argument(arguments[1])));
end method;

define method invoke-operation (object :: CosNaming/<NamingContext-servant>, request :: CORBA/<ServerRequest>, operation == #"bind_context")
 => ()
  let arguments = make(CORBA/<NVList>);
  let n = make(CORBA/<NamedValue>, name: "n", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), max-length: 0, element-typecode: class-typecode(CosNaming/<NameComponent>))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, n);
  let nc = make(CORBA/<NamedValue>, name: "nc", argument: make(CORBA/<any>, type: class-typecode(CosNaming/<NamingContext>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nc);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/NamingContext/bind-context(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), as(CosNaming/<NamingContext>, CORBA/any/value(CORBA/NamedValue/argument(arguments[1]))));
end method;

define method invoke-operation (object :: CosNaming/<NamingContext-servant>, request :: CORBA/<ServerRequest>, operation == #"rebind_context")
 => ()
  let arguments = make(CORBA/<NVList>);
  let n = make(CORBA/<NamedValue>, name: "n", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), max-length: 0, element-typecode: class-typecode(CosNaming/<NameComponent>))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, n);
  let nc = make(CORBA/<NamedValue>, name: "nc", argument: make(CORBA/<any>, type: class-typecode(CosNaming/<NamingContext>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, nc);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/NamingContext/rebind-context(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])), as(CosNaming/<NamingContext>, CORBA/any/value(CORBA/NamedValue/argument(arguments[1]))));
end method;

define method invoke-operation (object :: CosNaming/<NamingContext-servant>, request :: CORBA/<ServerRequest>, operation == #"resolve")
 => ()
  let arguments = make(CORBA/<NVList>);
  let n = make(CORBA/<NamedValue>, name: "n", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), max-length: 0, element-typecode: class-typecode(CosNaming/<NameComponent>))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, n);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/NamingContext/resolve(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: class-typecode(<object-reference>), value: results[0]));
end method;

define method invoke-operation (object :: CosNaming/<NamingContext-servant>, request :: CORBA/<ServerRequest>, operation == #"unbind")
 => ()
  let arguments = make(CORBA/<NVList>);
  let n = make(CORBA/<NamedValue>, name: "n", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), max-length: 0, element-typecode: class-typecode(CosNaming/<NameComponent>))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, n);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/NamingContext/unbind(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
end method;

define method invoke-operation (object :: CosNaming/<NamingContext-servant>, request :: CORBA/<ServerRequest>, operation == #"new_context")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/NamingContext/new-context(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: class-typecode(CosNaming/<NamingContext>), value: results[0]));
end method;

define method invoke-operation (object :: CosNaming/<NamingContext-servant>, request :: CORBA/<ServerRequest>, operation == #"bind_new_context")
 => ()
  let arguments = make(CORBA/<NVList>);
  let n = make(CORBA/<NamedValue>, name: "n", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), type: limited(CORBA/<sequence>, of: CosNaming/<NameComponent>), max-length: 0, element-typecode: class-typecode(CosNaming/<NameComponent>))), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, n);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/NamingContext/bind-new-context(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: class-typecode(CosNaming/<NamingContext>), value: results[0]));
end method;

define method invoke-operation (object :: CosNaming/<NamingContext-servant>, request :: CORBA/<ServerRequest>, operation == #"destroy")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/NamingContext/destroy(object);
end method;

define method invoke-operation (object :: CosNaming/<NamingContext-servant>, request :: CORBA/<ServerRequest>, operation == #"list")
 => ()
  let arguments = make(CORBA/<NVList>);
  let how-many = make(CORBA/<NamedValue>, name: "how-many", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, how-many);
  let bl = make(CORBA/<NamedValue>, name: "bl", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<Binding>), type: limited(CORBA/<sequence>, of: CosNaming/<Binding>), max-length: 0, element-typecode: class-typecode(CosNaming/<Binding>))), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, bl);
  let bi = make(CORBA/<NamedValue>, name: "bi", argument: make(CORBA/<any>, type: class-typecode(CosNaming/<BindingIterator>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, bi);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/NamingContext/list(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<Binding>), type: limited(CORBA/<sequence>, of: CosNaming/<Binding>), max-length: 0, element-typecode: class-typecode(CosNaming/<Binding>)), value: results[0]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
  arguments[2] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[2]), argument: make(CORBA/<any>, type: class-typecode(CosNaming/<BindingIterator>), value: results[1]), len: CORBA/NamedValue/len(arguments[2]), arg-modes: CORBA/NamedValue/arg-modes(arguments[2]));
end method;

define method invoke-operation (object :: CosNaming/<BindingIterator-servant>, request :: CORBA/<ServerRequest>, operation == #"next_one")
 => ()
  let arguments = make(CORBA/<NVList>);
  let b = make(CORBA/<NamedValue>, name: "b", argument: make(CORBA/<any>, type: class-typecode(CosNaming/<Binding>)), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, b);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/BindingIterator/next-one(object);
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<boolean-typecode>), value: results[0]));
  arguments[0] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[0]), argument: make(CORBA/<any>, type: class-typecode(CosNaming/<Binding>), value: results[1]), len: CORBA/NamedValue/len(arguments[0]), arg-modes: CORBA/NamedValue/arg-modes(arguments[0]));
end method;

define method invoke-operation (object :: CosNaming/<BindingIterator-servant>, request :: CORBA/<ServerRequest>, operation == #"next_n")
 => ()
  let arguments = make(CORBA/<NVList>);
  let how-many = make(CORBA/<NamedValue>, name: "how-many", argument: make(CORBA/<any>, type: make(<unsigned-long-typecode>)), len: 0, arg-modes: CORBA/$ARG-IN);
  arguments := add!(arguments, how-many);
  let bl = make(CORBA/<NamedValue>, name: "bl", argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<Binding>), type: limited(CORBA/<sequence>, of: CosNaming/<Binding>), max-length: 0, element-typecode: class-typecode(CosNaming/<Binding>))), len: 0, arg-modes: CORBA/$ARG-OUT);
  arguments := add!(arguments, bl);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/BindingIterator/next-n(object, CORBA/any/value(CORBA/NamedValue/argument(arguments[0])));
  CORBA/ServerRequest/set-result(request, make(CORBA/<any>, type: make(<boolean-typecode>), value: results[0]));
  arguments[1] := make(CORBA/<NamedValue>, name: CORBA/NamedValue/name(arguments[1]), argument: make(CORBA/<any>, type: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CosNaming/<Binding>), type: limited(CORBA/<sequence>, of: CosNaming/<Binding>), max-length: 0, element-typecode: class-typecode(CosNaming/<Binding>)), value: results[1]), len: CORBA/NamedValue/len(arguments[1]), arg-modes: CORBA/NamedValue/arg-modes(arguments[1]));
end method;

define method invoke-operation (object :: CosNaming/<BindingIterator-servant>, request :: CORBA/<ServerRequest>, operation == #"destroy")
 => ()
  let arguments = make(CORBA/<NVList>);
  arguments := CORBA/ServerRequest/arguments(request, arguments);
  let (#rest results) = CosNaming/BindingIterator/destroy(object);
end method;


/* eof */
