Module:  dylan-user
Author: yduJ
Copyright:    Original Code is Copyright (c) 1995-2004 Functional Objects, Inc.
              All rights reserved.
License:      See License.txt in this distribution for details.
Warranty:     Distributed WITHOUT WARRANTY OF ANY KIND

define library odbc-ffi
  use dylan;
  use c-ffi;
  use io;
	
  export odbc-ffi;
end library;

define module odbc-ffi
  use dylan;
  use c-ffi;
  use format-out;

  export
        *trace-odbc-functions*,

  // from "ctl3d.h":
        $CTL3D-SUBCLASS-DYNCREATE,
        $CTL3D-NOSUBCLASS-DYNCREATE, $CTL3D-BUTTON-CTL, $CTL3D-LISTBOX-CTL,
        $CTL3D-EDIT-CTL, $CTL3D-COMBO-CTL, $CTL3D-STATIC-CTL, $CTL3D-BUTTONS,
        $CTL3D-LISTBOXES, $CTL3D-EDITS, $CTL3D-COMBOS, $CTL3D-STATICTEXTS,
        $CTL3D-STATICFRAMES, $CTL3D-ALL, $CTL3D-NOBORDER, $CTL3D-BORDER,
        $CTL3D-NOSUBCLASS, $CTL3D-SUBCLASS, $CTL3D-3DCHECK,
  // from "odbcinst.h":
        $ODBCVER, $ODBC-ADD-DSN, $ODBC-CONFIG-DSN, $ODBC-REMOVE-DSN,
        $ODBC-ADD-SYS-DSN, $ODBC-CONFIG-SYS-DSN, $ODBC-REMOVE-SYS-DSN,
        $ODBC-REMOVE-DEFAULT-DSN, $ODBC-INSTALL-INQUIRY,
        $ODBC-INSTALL-COMPLETE, $ODBC-INSTALL-DRIVER, $ODBC-REMOVE-DRIVER,
        $ODBC-CONFIG-DRIVER, $ODBC-CONFIG-DRIVER-MAX, $ODBC-BOTH-DSN,
        $ODBC-USER-DSN, $ODBC-SYSTEM-DSN, $ODBC-ERROR-GENERAL-ERR,
        $ODBC-ERROR-INVALID-BUFF-LEN, $ODBC-ERROR-INVALID-HWND,
        $ODBC-ERROR-INVALID-STR, $ODBC-ERROR-INVALID-REQUEST-TYPE,
        $ODBC-ERROR-COMPONENT-NOT-FOUND, $ODBC-ERROR-INVALID-NAME,
        $ODBC-ERROR-INVALID-KEYWORD-VALUE, $ODBC-ERROR-INVALID-DSN,
        $ODBC-ERROR-INVALID-INF, $ODBC-ERROR-REQUEST-FAILED,
        $ODBC-ERROR-INVALID-PATH, $ODBC-ERROR-LOAD-LIB-FAILED,
        $ODBC-ERROR-INVALID-PARAM-SEQUENCE, $ODBC-ERROR-INVALID-LOG-FILE,
        $ODBC-ERROR-USER-CANCELED, $ODBC-ERROR-USAGE-UPDATE-FAILED,
        $ODBC-ERROR-CREATE-DSN-FAILED, $ODBC-ERROR-WRITING-SYSINFO-FAILED,
        $ODBC-ERROR-REMOVE-DSN-FAILED, $ODBC-ERROR-OUT-OF-MEM,
        $ODBC-ERROR-OUTPUT-STRING-TRUNCATED, 
  // from "odbcss.h":
        $SQL-COPT-SS-BASE, $SQL-REMOTE-PWD,
        $SQL-USE-PROCEDURE-FOR-PREPARE, $SQL-INTEGRATED-SECURITY,
        $SQL-PRESERVE-CURSORS, $SQL-COPT-SS-USER-DATA, $SQL-COPT-SS-ANSI-OEM,
        $SQL-COPT-SS-CONNECTION-DEAD, $SQL-COPT-SS-FALLBACK-CONNECT,
        $SQL-COPT-SS-PERF-DATA, $SQL-COPT-SS-PERF-DATA-LOG,
        $SQL-COPT-SS-PERF-QUERY-INTERVAL, $SQL-COPT-SS-PERF-QUERY-LOG,
        $SQL-COPT-SS-PERF-QUERY, $SQL-COPT-SS-PERF-DATA-LOG-NOW,
        $SQL-COPT-SS-PERF-QUERY-AUTO-LOG, $SQL-COPT-SS-PERF-DATA-AUTO-LOG,
        $SQL-COPT-SS-BCP, $SQL-SOPT-SS-BASE, $SQL-TEXTPTR-LOGGING,
        $SQL-SOPT-SS-CURRENT-COMMAND, $SQL-SOPT-SS-HIDDEN-COLUMNS,
        $SQL-SOPT-SS-MAX-USED, $SQL-UP-OFF, $SQL-UP-ON, $SQL-UP-ON-DROP,
        $SQL-UP-DEFAULT, $SQL-IS-OFF, $SQL-IS-ON, $SQL-IS-DEFAULT,
        $SQL-PC-OFF, $SQL-PC-ON, $SQL-PC-DEFAULT, $SQL-AO-OFF, $SQL-AO-ON,
        $SQL-AO-DEFAULT, $SQL-CD-TRUE, $SQL-CD-FALSE, $SQL-FB-OFF,
        $SQL-FB-ON, $SQL-FB-DEFAULT, $SQL-DTC-DONE, $SQL-BCP-OFF,
        $SQL-BCP-ON, $SQL-BCP-DEFAULT, $SQL-TL-OFF, $SQL-TL-ON,
        $SQL-TL-DEFAULT, $SQL-HC-OFF, $SQL-HC-ON, $SQL-HC-DEFAULT,
        $SQL-CA-SS-COLUMN-SSTYPE, $SQL-CA-SS-COLUMN-UTYPE,
        $SQL-CA-SS-NUM-ORDERS, $SQL-CA-SS-COLUMN-ORDER,
        $SQL-CA-SS-COLUMN-VARYLEN, $SQL-CA-SS-NUM-COMPUTES,
        $SQL-CA-SS-COMPUTE-ID, $SQL-CA-SS-COMPUTE-BYLIST,
        $SQL-CA-SS-COLUMN-ID, $SQL-CA-SS-COLUMN-OP, $SQL-CA-SS-COLUMN-SIZE,
        $SQL-CA-SS-COLUMN-HIDDEN, $SQL-CA-SS-COLUMN-KEY, $SQL-CA-SS-MAX-USED,
        $SQLTEXT, $SQLVARBINARY, $SQLINTN, $SQLVARCHAR, $SQLBINARY,
        $SQLIMAGE, $SQLCHARACTER, $SQLINT1, $SQLBIT, $SQLINT2, $SQLINT4,
        $SQLMONEY, $SQLDATETIME, $SQLFLT8, $SQLFLTN, $SQLMONEYN,
        $SQLDATETIMN, $SQLFLT4, $SQLMONEY4, $SQLDATETIM4, $SQLDECIMAL,
        $SQLDECIMALN, $SQLNUMERIC, $SQLNUMERICN, $SQLudtTEXT,
        $SQLudtVARBINARY, $SQLudtINTN, $SQLudtVARCHAR, $SQLudtBINARY,
        $SQLudtIMAGE, $SQLudtCHAR, $SQLudtINT1, $SQLudtBIT, $SQLudtINT2,
        $SQLudtINT4, $SQLudtMONEY, $SQLudtDATETIME, $SQLudtFLT8, $SQLudtFLTN,
        $SQLudtMONEYN, $SQLudtDATETIMN, $SQLudtSYSNAME, $SQLudtTIMESTAMP,
        $SQLudtFLT4, $SQLudtMONEY4, $SQLudtDATETIM4, $SQLudtDECML,
        $SQLudtDECMLN, $SQLudtNUM, $SQLudtNUMN, $MIN-USER-DATATYPE,
        $SQLAOPCNT, $SQLAOPSUM, $SQLAOPAVG, $SQLAOPMIN, $SQLAOPMAX,
        $SQLAOPANY, $SQLAOPNOOP, $SQL-INFO-SS-NETLIB-NAME,
        $SQL-INFO-SS-MAX-USED, $SQL-DIAG-SS-MSGSTATE, $DBMAXCHAR, $MAXNAME,
        $MAXNUMERICLEN, $MAXNUMERICLEN,
        $SQL-PERF-START, $SQL-PERF-STOP, $FAIL, $DB-OUT, $BCPFIRST, $BCPLAST,
        $BCPBATCH, $BCPKEEPNULLS, $BCPABORT, 
        $SQL-FC-OFF, $SQL-FC-ON, $SQL-FC-DEFAULT,
        $SQL-COPT-SS-ENLIST-IN-DTC, $SQL-COPT-SS-ENLIST-IN-XA,
  // from "odbcver.h":
//nuked $VER-FILEOS.  was defined to be VOS_NT_WINDOWS32, what's that?
        $VER-FILEFLAGS, $VER-FILEFLAGS,

  // from "sql.h":
        $ODBCVER, $SQL-NULL-DATA, $SQL-DATA-AT-EXEC, $SQL-SUCCESS,
        $SQL-SUCCESS-WITH-INFO, $SQL-NO-DATA, $SQL-ERROR,
        $SQL-INVALID-HANDLE, $SQL-NEED-DATA, $SQL-NTS, $SQL-NTSL,
        $SQL-MAX-MESSAGE-LENGTH, $SQL-DATE-LEN, $SQL-HANDLE-ENV,
        $SQL-HANDLE-DBC, $SQL-HANDLE-STMT, $SQL-HANDLE-DESC,
        $SQL-ATTR-OUTPUT-NTS, $SQL-ATTR-AUTO-IPD, $SQL-ATTR-METADATA-ID,
        $SQL-ATTR-APP-ROW-DESC, $SQL-ATTR-APP-PARAM-DESC,
        $SQL-ATTR-IMP-ROW-DESC, $SQL-ATTR-IMP-PARAM-DESC,
        $SQL-ATTR-CURSOR-SCROLLABLE, $SQL-ATTR-CURSOR-SENSITIVITY,
        $SQL-NONSCROLLABLE, $SQL-SCROLLABLE, $SQL-DESC-COUNT, $SQL-DESC-TYPE,
        $SQL-DESC-LENGTH, $SQL-DESC-OCTET-LENGTH-PTR, $SQL-DESC-PRECISION,
        $SQL-DESC-SCALE, $SQL-DESC-DATETIME-INTERVAL-CODE,
        $SQL-DESC-NULLABLE, $SQL-DESC-INDICATOR-PTR, $SQL-DESC-DATA-PTR,
        $SQL-DESC-NAME, $SQL-DESC-UNNAMED, $SQL-DESC-OCTET-LENGTH,
        $SQL-DESC-ALLOC-TYPE, $SQL-DIAG-RETURNCODE, $SQL-DIAG-NUMBER,
        $SQL-DIAG-ROW-COUNT, $SQL-DIAG-SQLSTATE, $SQL-DIAG-NATIVE,
        $SQL-DIAG-MESSAGE-TEXT, $SQL-DIAG-DYNAMIC-FUNCTION,
        $SQL-DIAG-CLASS-ORIGIN, $SQL-DIAG-SUBCLASS-ORIGIN,
        $SQL-DIAG-CONNECTION-NAME, $SQL-DIAG-SERVER-NAME,
        $SQL-DIAG-DYNAMIC-FUNCTION-CODE, $SQL-DIAG-ALTER-TABLE,
        $SQL-DIAG-CREATE-INDEX, $SQL-DIAG-CREATE-TABLE,
        $SQL-DIAG-CREATE-VIEW, $SQL-DIAG-DELETE-WHERE, $SQL-DIAG-DROP-INDEX,
        $SQL-DIAG-DROP-TABLE, $SQL-DIAG-DROP-VIEW,
        $SQL-DIAG-DYNAMIC-DELETE-CURSOR, $SQL-DIAG-DYNAMIC-UPDATE-CURSOR,
        $SQL-DIAG-GRANT, $SQL-DIAG-INSERT, $SQL-DIAG-REVOKE,
        $SQL-DIAG-SELECT-CURSOR, $SQL-DIAG-UNKNOWN-STATEMENT,
        $SQL-DIAG-UPDATE-WHERE, $SQL-UNKNOWN-TYPE, $SQL-CHAR, $SQL-NUMERIC,
        $SQL-DECIMAL, $SQL-INTEGER, $SQL-SMALLINT, $SQL-FLOAT, $SQL-REAL,
        $SQL-DOUBLE, $SQL-DATETIME, $SQL-VARCHAR, $SQL-TYPE-DATE,
        $SQL-TYPE-TIME, $SQL-TYPE-TIMESTAMP, $SQL-LONGVARCHAR, $SQL-BINARY, 
        $SQL-VARBINARY, $SQL-LONGVARBINARY, $SQL-BIGINT, $SQL-TINYINT, $SQL-BIT, $SQL-UNSPECIFIED,
        $SQL-INSENSITIVE, $SQL-SENSITIVE, $SQL-ALL-TYPES, $SQL-DEFAULT,
        $SQL-ARD-TYPE, $SQL-CODE-DATE, $SQL-CODE-TIME, $SQL-CODE-TIMESTAMP,
        $SQL-FALSE, $SQL-TRUE, $SQL-NO-NULLS, $SQL-NULLABLE,
        $SQL-NULLABLE-UNKNOWN, $SQL-PRED-NONE, $SQL-PRED-CHAR,
        $SQL-PRED-BASIC, $SQL-NAMED, $SQL-UNNAMED, $SQL-DESC-ALLOC-AUTO,
        $SQL-DESC-ALLOC-USER, $SQL-CLOSE, $SQL-DROP, $SQL-UNBIND,
        $SQL-RESET-PARAMS, $SQL-FETCH-NEXT, $SQL-FETCH-FIRST,
        $SQL-FETCH-LAST, $SQL-FETCH-PRIOR, $SQL-FETCH-ABSOLUTE,
        $SQL-FETCH-RELATIVE, $SQL-COMMIT, $SQL-ROLLBACK, $SQL-NULL-HENV,
        $SQL-NULL-HDBC, $SQL-NULL-HSTMT, $SQL-NULL-HDESC, $SQL-NULL-HANDLE,
        $SQL-SCOPE-CURROW, $SQL-SCOPE-TRANSACTION, $SQL-SCOPE-SESSION,
        $SQL-PC-NON-PSEUDO, $SQL-PC-PSEUDO, $SQL-ROW-IDENTIFIER,
        $SQL-INDEX-UNIQUE, $SQL-INDEX-ALL, $SQL-INDEX-CLUSTERED,
        $SQL-INDEX-HASHED, $SQL-INDEX-OTHER, $SQL-API-SQLALLOCCONNECT,
        $SQL-API-SQLALLOCENV, $SQL-API-SQLALLOCHANDLE, $SQL-API-SQLALLOCSTMT,
        $SQL-API-SQLBINDCOL, $SQL-API-SQLBINDPARAM, $SQL-API-SQLCANCEL,
        $SQL-API-SQLCLOSECURSOR, $SQL-API-SQLCOLATTRIBUTE,
        $SQL-API-SQLCOLUMNS, $SQL-API-SQLCONNECT, $SQL-API-SQLCOPYDESC,
        $SQL-API-SQLDATASOURCES, $SQL-API-SQLDESCRIBECOL,
        $SQL-API-SQLDISCONNECT, $SQL-API-SQLENDTRAN, $SQL-API-SQLERROR,
        $SQL-API-SQLEXECDIRECT, $SQL-API-SQLEXECUTE, $SQL-API-SQLFETCH,
        $SQL-API-SQLFETCHSCROLL, $SQL-API-SQLFREECONNECT,
        $SQL-API-SQLFREEENV, $SQL-API-SQLFREEHANDLE, $SQL-API-SQLFREESTMT,
        $SQL-API-SQLGETCONNECTATTR, $SQL-API-SQLGETCONNECTOPTION,
        $SQL-API-SQLGETCURSORNAME, $SQL-API-SQLGETDATA,
        $SQL-API-SQLGETDESCFIELD, $SQL-API-SQLGETDESCREC,
        $SQL-API-SQLGETDIAGFIELD, $SQL-API-SQLGETDIAGREC,
        $SQL-API-SQLGETENVATTR, $SQL-API-SQLGETFUNCTIONS,
        $SQL-API-SQLGETINFO, $SQL-API-SQLGETSTMTATTR,
        $SQL-API-SQLGETSTMTOPTION, $SQL-API-SQLGETTYPEINFO,
        $SQL-API-SQLNUMRESULTCOLS, $SQL-API-SQLPARAMDATA,
        $SQL-API-SQLPREPARE, $SQL-API-SQLPUTDATA, $SQL-API-SQLROWCOUNT,
        $SQL-API-SQLSETCONNECTATTR, $SQL-API-SQLSETCONNECTOPTION,
        $SQL-API-SQLSETCURSORNAME, $SQL-API-SQLSETDESCFIELD,
        $SQL-API-SQLSETDESCREC, $SQL-API-SQLSETENVATTR, $SQL-API-SQLSETPARAM,
        $SQL-API-SQLSETSTMTATTR, $SQL-API-SQLSETSTMTOPTION,
        $SQL-API-SQLSPECIALCOLUMNS, $SQL-API-SQLSTATISTICS,
        $SQL-API-SQLTABLES, $SQL-API-SQLTRANSACT,
        $SQL-MAX-DRIVER-CONNECTIONS, $SQL-MAXIMUM-DRIVER-CONNECTIONS,
        $SQL-MAX-CONCURRENT-ACTIVITIES, $SQL-MAXIMUM-CONCURRENT-ACTIVITIES,
        $SQL-DATA-SOURCE-NAME, $SQL-FETCH-DIRECTION, $SQL-SERVER-NAME,
        $SQL-SEARCH-PATTERN-ESCAPE, $SQL-DBMS-NAME, $SQL-DBMS-VER,
        $SQL-ACCESSIBLE-TABLES, $SQL-ACCESSIBLE-PROCEDURES,
        $SQL-CURSOR-COMMIT-BEHAVIOR, $SQL-DATA-SOURCE-READ-ONLY,
        $SQL-DEFAULT-TXN-ISOLATION, $SQL-IDENTIFIER-CASE,
        $SQL-IDENTIFIER-QUOTE-CHAR, $SQL-MAX-COLUMN-NAME-LEN,
        $SQL-MAXIMUM-COLUMN-NAME-LENGTH, $SQL-MAX-CURSOR-NAME-LEN,
        $SQL-MAXIMUM-CURSOR-NAME-LENGTH, $SQL-MAX-SCHEMA-NAME-LEN,
        $SQL-MAXIMUM-SCHEMA-NAME-LENGTH, $SQL-MAX-CATALOG-NAME-LEN,
        $SQL-MAXIMUM-CATALOG-NAME-LENGTH, $SQL-MAX-TABLE-NAME-LEN,
        $SQL-SCROLL-CONCURRENCY, $SQL-TXN-CAPABLE, $SQL-TRANSACTION-CAPABLE,
        $SQL-USER-NAME, $SQL-TXN-ISOLATION-OPTION,
        $SQL-TRANSACTION-ISOLATION-OPTION, $SQL-INTEGRITY,
        $SQL-GETDATA-EXTENSIONS, $SQL-NULL-COLLATION, $SQL-ALTER-TABLE,
        $SQL-ORDER-BY-COLUMNS-IN-SELECT, $SQL-SPECIAL-CHARACTERS,
        $SQL-MAX-COLUMNS-IN-GROUP-BY, $SQL-MAXIMUM-COLUMNS-IN-GROUP-BY,
        $SQL-MAX-COLUMNS-IN-INDEX, $SQL-MAXIMUM-COLUMNS-IN-INDEX,
        $SQL-MAX-COLUMNS-IN-ORDER-BY, $SQL-MAXIMUM-COLUMNS-IN-ORDER-BY,
        $SQL-MAX-COLUMNS-IN-SELECT, $SQL-MAXIMUM-COLUMNS-IN-SELECT,
        $SQL-MAX-COLUMNS-IN-TABLE, $SQL-MAX-INDEX-SIZE,
        $SQL-MAXIMUM-INDEX-SIZE, $SQL-MAX-ROW-SIZE, $SQL-MAXIMUM-ROW-SIZE,
        $SQL-MAX-STATEMENT-LEN, $SQL-MAXIMUM-STATEMENT-LENGTH,
        $SQL-MAX-TABLES-IN-SELECT, $SQL-MAXIMUM-TABLES-IN-SELECT,
        $SQL-MAX-USER-NAME-LEN, $SQL-MAXIMUM-USER-NAME-LENGTH,
        $SQL-OJ-CAPABILITIES, $SQL-OUTER-JOIN-CAPABILITIES,
        $SQL-XOPEN-CLI-YEAR, $SQL-CURSOR-SENSITIVITY,
        $SQL-DESCRIBE-PARAMETER, $SQL-CATALOG-NAME, $SQL-COLLATION-SEQ,
        $SQL-MAX-IDENTIFIER-LEN, $SQL-MAXIMUM-IDENTIFIER-LENGTH,
        $SQL-AT-ADD-COLUMN, $SQL-AT-DROP-COLUMN, $SQL-AT-ADD-CONSTRAINT,
        $SQL-AM-NONE, $SQL-AM-CONNECTION, $SQL-AM-STATEMENT, $SQL-CB-DELETE,
        $SQL-CB-CLOSE, $SQL-CB-PRESERVE, $SQL-FD-FETCH-NEXT,
        $SQL-FD-FETCH-FIRST, $SQL-FD-FETCH-LAST, $SQL-FD-FETCH-PRIOR,
        $SQL-FD-FETCH-ABSOLUTE, $SQL-FD-FETCH-RELATIVE, $SQL-GD-ANY-COLUMN,
        $SQL-GD-ANY-ORDER, $SQL-IC-UPPER, $SQL-IC-LOWER, $SQL-IC-SENSITIVE,
        $SQL-IC-MIXED, $SQL-OJ-LEFT, $SQL-OJ-RIGHT, $SQL-OJ-FULL,
        $SQL-OJ-NESTED, $SQL-OJ-NOT-ORDERED, $SQL-OJ-INNER,
        $SQL-OJ-ALL-COMPARISON-OPS, $SQL-SCCO-READ-ONLY, $SQL-SCCO-LOCK,
        $SQL-SCCO-OPT-ROWVER, $SQL-SCCO-OPT-VALUES, $SQL-TC-NONE,
        $SQL-TC-DML, $SQL-TC-ALL, $SQL-TC-DDL-COMMIT, $SQL-TC-DDL-IGNORE,
        $SQL-TXN-READ-UNCOMMITTED, $SQL-TRANSACTION-READ-UNCOMMITTED,
        $SQL-TXN-READ-COMMITTED, $SQL-TRANSACTION-READ-COMMITTED,
        $SQL-TXN-REPEATABLE-READ, $SQL-TRANSACTION-REPEATABLE-READ,
        $SQL-TXN-SERIALIZABLE, $SQL-TRANSACTION-SERIALIZABLE, $SQL-NC-HIGH,
        $SQL-NC-LOW, 
  // from "sqlext.h":
        $SQL-NO-DATA-FOUND, $SQL-NO-DATA-FOUND, $SQL-HANDLE-SENV,
        $SQL-ATTR-ODBC-VERSION, $SQL-ATTR-CONNECTION-POOLING,
        $SQL-ATTR-CP-MATCH, $SQL-CP-OFF, $SQL-CP-ONE-PER-DRIVER,
        $SQL-CP-ONE-PER-HENV, $SQL-CP-DEFAULT, $SQL-CP-STRICT-MATCH,
        $SQL-CP-RELAXED-MATCH, $SQL-CP-MATCH-DEFAULT, $SQL-OV-ODBC2,
        $SQL-OV-ODBC3, $SQL-ACCESS-MODE, $SQL-AUTOCOMMIT, $SQL-LOGIN-TIMEOUT,
        $SQL-OPT-TRACE, $SQL-OPT-TRACEFILE, $SQL-TRANSLATE-DLL,
        $SQL-TRANSLATE-OPTION, $SQL-TXN-ISOLATION, $SQL-CURRENT-QUALIFIER,
        $SQL-ODBC-CURSORS, $SQL-QUIET-MODE, $SQL-PACKET-SIZE,
        $SQL-ATTR-ACCESS-MODE, $SQL-ATTR-AUTOCOMMIT,
        $SQL-ATTR-CONNECTION-TIMEOUT, $SQL-ATTR-CURRENT-CATALOG,
        $SQL-ATTR-DISCONNECT-BEHAVIOR, $SQL-ATTR-ENLIST-IN-DTC,
        $SQL-ATTR-ENLIST-IN-XA, $SQL-ATTR-LOGIN-TIMEOUT,
        $SQL-ATTR-ODBC-CURSORS, $SQL-ATTR-PACKET-SIZE, $SQL-ATTR-QUIET-MODE,
        $SQL-ATTR-TRACE, $SQL-ATTR-TRACEFILE, $SQL-ATTR-TRANSLATE-LIB,
        $SQL-ATTR-TRANSLATE-OPTION, $SQL-ATTR-TXN-ISOLATION,
        $SQL-CONNECT-OPT-DRVR-START, $SQL-CONN-OPT-MAX, $SQL-CONN-OPT-MIN,
        $SQL-MODE-READ-WRITE, $SQL-MODE-READ-ONLY, $SQL-MODE-DEFAULT,
        $SQL-AUTOCOMMIT-OFF, $SQL-AUTOCOMMIT-ON, $SQL-AUTOCOMMIT-DEFAULT,
        $SQL-LOGIN-TIMEOUT-DEFAULT, $SQL-OPT-TRACE-OFF, $SQL-OPT-TRACE-ON,
        $SQL-OPT-TRACE-DEFAULT, $SQL-CUR-USE-IF-NEEDED, $SQL-CUR-USE-ODBC,
        $SQL-CUR-USE-DRIVER, $SQL-CUR-DEFAULT, $SQL-DB-RETURN-TO-POOL,
        $SQL-DB-DISCONNECT, $SQL-DB-DEFAULT, $SQL-DTC-DONE,
        $SQL-QUERY-TIMEOUT, $SQL-MAX-ROWS, $SQL-NOSCAN, $SQL-MAX-LENGTH,
        $SQL-BIND-TYPE, $SQL-CURSOR-TYPE, $SQL-CONCURRENCY, $SQL-KEYSET-SIZE,
        $SQL-ROWSET-SIZE, $SQL-SIMULATE-CURSOR, $SQL-RETRIEVE-DATA,
        $SQL-USE-BOOKMARKS, $SQL-ATTR-ASYNC-ENABLE, $SQL-ATTR-CONCURRENCY,
        $SQL-ATTR-CURSOR-TYPE, $SQL-ATTR-ENABLE-AUTO-IPD,
        $SQL-ATTR-FETCH-BOOKMARK-PTR, $SQL-ATTR-KEYSET-SIZE,
        $SQL-ATTR-MAX-LENGTH, $SQL-ATTR-MAX-ROWS, $SQL-ATTR-NOSCAN,
        $SQL-ATTR-PARAM-BIND-OFFSET-PTR, $SQL-ATTR-PARAM-BIND-TYPE,
        $SQL-ATTR-PARAM-OPERATION-PTR, $SQL-ATTR-PARAM-STATUS-PTR,
        $SQL-ATTR-PARAMS-PROCESSED-PTR, $SQL-ATTR-PARAMSET-SIZE,
        $SQL-ATTR-QUERY-TIMEOUT, $SQL-ATTR-RETRIEVE-DATA,
        $SQL-ATTR-ROW-BIND-OFFSET-PTR, $SQL-ATTR-ROW-BIND-TYPE,
        $SQL-ATTR-ROW-OPERATION-PTR, $SQL-ATTR-ROW-STATUS-PTR,
        $SQL-ATTR-ROWS-FETCHED-PTR, $SQL-ATTR-ROW-ARRAY-SIZE,
        $SQL-ATTR-SIMULATE-CURSOR, $SQL-ATTR-USE-BOOKMARKS,
        $SQL-STMT-OPT-MAX, $SQL-STMT-OPT-MIN, $SQL-COL-PRED-CHAR,
        $SQL-COL-PRED-BASIC, $SQL-IS-POINTER, $SQL-IS-UINTEGER,
        $SQL-IS-INTEGER, $SQL-IS-USMALLINT, $SQL-IS-SMALLINT,
        $SQL-PARAM-BIND-BY-COLUMN, $SQL-PARAM-BIND-TYPE-DEFAULT,
        $SQL-QUERY-TIMEOUT-DEFAULT, $SQL-MAX-ROWS-DEFAULT,
        $SQL-NOSCAN-DEFAULT, $SQL-MAX-LENGTH-DEFAULT, $SQL-ASYNC-ENABLE-OFF,
        $SQL-ASYNC-ENABLE-ON, $SQL-ASYNC-ENABLE-DEFAULT, $SQL-BIND-BY-COLUMN,
        $SQL-CONCUR-READ-ONLY, $SQL-CONCUR-LOCK, $SQL-CONCUR-ROWVER,
        $SQL-CONCUR-VALUES, $SQL-CURSOR-FORWARD-ONLY,
        $SQL-CURSOR-KEYSET-DRIVEN, $SQL-CURSOR-DYNAMIC, $SQL-CURSOR-STATIC,
        $SQL-ROWSET-SIZE-DEFAULT, $SQL-KEYSET-SIZE-DEFAULT,
        $SQL-SC-NON-UNIQUE, $SQL-SC-TRY-UNIQUE, $SQL-SC-UNIQUE, $SQL-RD-OFF,
        $SQL-RD-ON, $SQL-RD-DEFAULT, $SQL-UB-OFF, $SQL-UB-ON,
        $SQL-UB-DEFAULT, $SQL-UB-FIXED, $SQL-UB-VARIABLE,
        $SQL-DESC-ARRAY-SIZE, $SQL-DESC-ARRAY-STATUS-PTR,
        $SQL-DESC-AUTO-UNIQUE-VALUE, $SQL-DESC-BASE-COLUMN-NAME,
        $SQL-DESC-BASE-TABLE-NAME, $SQL-DESC-BIND-OFFSET-PTR,
        $SQL-DESC-BIND-TYPE, $SQL-DESC-CASE-SENSITIVE,
        $SQL-DESC-CATALOG-NAME, $SQL-DESC-CONCISE-TYPE,
        $SQL-DESC-DATETIME-INTERVAL-PRECISION, $SQL-DESC-DISPLAY-SIZE,
        $SQL-DESC-FIXED-PREC-SCALE, $SQL-DESC-LABEL,
        $SQL-DESC-LITERAL-PREFIX, $SQL-DESC-LITERAL-SUFFIX,
        $SQL-DESC-LOCAL-TYPE-NAME, $SQL-DESC-MAXIMUM-SCALE,
        $SQL-DESC-MINIMUM-SCALE, $SQL-DESC-NUM-PREC-RADIX,
        $SQL-DESC-PARAMETER-TYPE, $SQL-DESC-ROWS-PROCESSED-PTR,
        $SQL-DESC-SCHEMA-NAME, $SQL-DESC-SEARCHABLE, $SQL-DESC-TYPE-NAME,
        $SQL-DESC-TABLE-NAME, $SQL-DESC-UNSIGNED, $SQL-DESC-UPDATABLE,
        $SQL-DIAG-CURSOR-ROW-COUNT, $SQL-DIAG-ROW-NUMBER,
        $SQL-DIAG-COLUMN-NUMBER, $SQL-DIAG-CALL, $SQL-DATE, $SQL-INTERVAL,
        $SQL-TIME, $SQL-TIMESTAMP, $SQL-LONGVARCHAR, $SQL-BINARY,
        $SQL-VARBINARY, $SQL-LONGVARBINARY, $SQL-BIGINT, $SQL-TINYINT,
        $SQL-BIT, $SQL-CODE-YEAR, $SQL-CODE-MONTH, $SQL-CODE-DAY,
        $SQL-CODE-HOUR, $SQL-CODE-MINUTE, $SQL-CODE-SECOND,
        $SQL-CODE-YEAR-TO-MONTH, $SQL-CODE-DAY-TO-HOUR,
        $SQL-CODE-DAY-TO-MINUTE, $SQL-CODE-DAY-TO-SECOND,
        $SQL-CODE-HOUR-TO-MINUTE, $SQL-CODE-HOUR-TO-SECOND,
        $SQL-CODE-MINUTE-TO-SECOND, $SQL-INTERVAL-YEAR, $SQL-INTERVAL-MONTH,
        $SQL-INTERVAL-YEAR-TO-MONTH, $SQL-INTERVAL-DAY, $SQL-INTERVAL-HOUR,
        $SQL-INTERVAL-MINUTE, $SQL-INTERVAL-SECOND,
        $SQL-INTERVAL-DAY-TO-HOUR, $SQL-INTERVAL-DAY-TO-MINUTE,
        $SQL-INTERVAL-DAY-TO-SECOND, $SQL-INTERVAL-HOUR-TO-MINUTE,
        $SQL-INTERVAL-HOUR-TO-SECOND, $SQL-INTERVAL-MINUTE-TO-SECOND,
        $SQL-UNICODE-VARCHAR, $SQL-UNICODE-LONGVARCHAR, $SQL-UNICODE-CHAR,
        $SQL-TYPE-DRIVER-START, $SQL-TYPE-DRIVER-END, $SQL-C-NUMERIC,
        $SQL-C-DEFAULT, $SQL-UNSIGNED-OFFSET, $SQL-C-DATE, $SQL-C-TIME,
        $SQL-C-TIMESTAMP, $SQL-C-TYPE-DATE, $SQL-C-TYPE-TIME,
        $SQL-C-TYPE-TIMESTAMP, $SQL-C-INTERVAL-YEAR, $SQL-C-INTERVAL-MONTH,
        $SQL-C-INTERVAL-DAY, $SQL-C-INTERVAL-HOUR, $SQL-C-INTERVAL-MINUTE,
        $SQL-C-INTERVAL-SECOND, $SQL-C-INTERVAL-YEAR-TO-MONTH,
        $SQL-C-INTERVAL-DAY-TO-HOUR, $SQL-C-INTERVAL-DAY-TO-MINUTE,
        $SQL-C-INTERVAL-DAY-TO-SECOND, $SQL-C-INTERVAL-HOUR-TO-MINUTE,
        $SQL-C-INTERVAL-HOUR-TO-SECOND, $SQL-C-INTERVAL-MINUTE-TO-SECOND,
        $SQL-C-BINARY, $SQL-C-BIT, $SQL-C-TINYINT, $SQL-TYPE-MIN,
        $SQL-TYPE-MAX, $SQL-C-VARBOOKMARK, $SQL-NO-ROW-NUMBER,
        $SQL-NO-COLUMN-NUMBER, $SQL-ROW-NUMBER-UNKNOWN,
        $SQL-COLUMN-NUMBER-UNKNOWN, $SQL-DEFAULT-PARAM, $SQL-IGNORE,
        $SQL-COLUMN-IGNORE, $SQL-LEN-DATA-AT-EXEC-OFFSET,
        $SQL-LEN-BINARY-ATTR-OFFSET, $SQL-PARAM-TYPE-DEFAULT,
        $SQL-SETPARAM-VALUE-MAX, $SQL-COLUMN-COUNT, $SQL-COLUMN-NAME,
        $SQL-COLUMN-TYPE, $SQL-COLUMN-LENGTH, $SQL-COLUMN-PRECISION,
        $SQL-COLUMN-SCALE, $SQL-COLUMN-DISPLAY-SIZE, $SQL-COLUMN-NULLABLE,
        $SQL-COLUMN-UNSIGNED, $SQL-COLUMN-MONEY, $SQL-COLUMN-UPDATABLE,
        $SQL-COLUMN-AUTO-INCREMENT, $SQL-COLUMN-CASE-SENSITIVE,
        $SQL-COLUMN-SEARCHABLE, $SQL-COLUMN-TYPE-NAME,
        $SQL-COLUMN-TABLE-NAME, $SQL-COLUMN-OWNER-NAME,
        $SQL-COLUMN-QUALIFIER-NAME, $SQL-COLUMN-LABEL, $SQL-COLATT-OPT-MAX,
        $SQL-COLUMN-DRIVER-START, $SQL-ATTR-READONLY, $SQL-ATTR-WRITE,
        $SQL-ATTR-READWRITE-UNKNOWN, $SQL-UNSEARCHABLE, $SQL-LIKE-ONLY,
        $SQL-ALL-EXCEPT-LIKE, $SQL-SEARCHABLE, $SQL-PRED-SEARCHABLE,
        $SQL-NO-TOTAL, $SQL-API-SQLALLOCHANDLESTD,
        $SQL-API-SQLBULKOPERATIONS, $SQL-API-SQLBINDPARAMETER,
        $SQL-API-SQLBROWSECONNECT, $SQL-API-SQLCOLATTRIBUTES,
        $SQL-API-SQLCOLUMNPRIVILEGES, $SQL-API-SQLDESCRIBEPARAM,
        $SQL-API-SQLDRIVERCONNECT, $SQL-API-SQLDRIVERS,
        $SQL-API-SQLEXTENDEDFETCH, $SQL-API-SQLFOREIGNKEYS,
        $SQL-API-SQLMORERESULTS, $SQL-API-SQLNATIVESQL,
        $SQL-API-SQLNUMPARAMS, $SQL-API-SQLPARAMOPTIONS,
        $SQL-API-SQLPRIMARYKEYS, $SQL-API-SQLPROCEDURECOLUMNS,
        $SQL-API-SQLPROCEDURES, $SQL-API-SQLSETPOS,
        $SQL-API-SQLSETSCROLLOPTIONS, $SQL-API-SQLTABLEPRIVILEGES,
        $SQL-EXT-API-LAST, $SQL-NUM-FUNCTIONS, $SQL-EXT-API-START,
        $SQL-API-ODBC3-ALL-FUNCTIONS, $SQL-INFO-FIRST, $SQL-DRIVER-HDBC,
        $SQL-DRIVER-HENV, $SQL-DRIVER-HSTMT, $SQL-DRIVER-NAME,
        $SQL-DRIVER-VER, $SQL-ODBC-API-CONFORMANCE, $SQL-ODBC-VER,
        $SQL-ROW-UPDATES, $SQL-ODBC-SAG-CLI-CONFORMANCE,
        $SQL-ODBC-SQL-CONFORMANCE, $SQL-PROCEDURES,
        $SQL-CONCAT-NULL-BEHAVIOR, $SQL-CURSOR-ROLLBACK-BEHAVIOR,
        $SQL-EXPRESSIONS-IN-ORDERBY, $SQL-MAX-PROCEDURE-NAME-LEN,
        $SQL-MULT-RESULT-SETS, $SQL-MULTIPLE-ACTIVE-TXN, $SQL-OUTER-JOINS,
        $SQL-OWNER-TERM, $SQL-PROCEDURE-TERM, $SQL-QUALIFIER-NAME-SEPARATOR,
        $SQL-QUALIFIER-TERM, $SQL-SCROLL-OPTIONS, $SQL-TABLE-TERM,
        $SQL-CONVERT-FUNCTIONS, $SQL-NUMERIC-FUNCTIONS,
        $SQL-STRING-FUNCTIONS, $SQL-SYSTEM-FUNCTIONS,
        $SQL-TIMEDATE-FUNCTIONS, $SQL-CONVERT-BIGINT, $SQL-CONVERT-BINARY,
        $SQL-CONVERT-BIT, $SQL-CONVERT-CHAR, $SQL-CONVERT-DATE,
        $SQL-CONVERT-DECIMAL, $SQL-CONVERT-DOUBLE, $SQL-CONVERT-FLOAT,
        $SQL-CONVERT-INTEGER, $SQL-CONVERT-LONGVARCHAR, $SQL-CONVERT-NUMERIC,
        $SQL-CONVERT-REAL, $SQL-CONVERT-SMALLINT, $SQL-CONVERT-TIME,
        $SQL-CONVERT-TIMESTAMP, $SQL-CONVERT-TINYINT, $SQL-CONVERT-VARBINARY,
        $SQL-CONVERT-VARCHAR, $SQL-CONVERT-LONGVARBINARY,
        $SQL-CORRELATION-NAME, $SQL-NON-NULLABLE-COLUMNS, $SQL-DRIVER-HLIB,
        $SQL-DRIVER-ODBC-VER, $SQL-LOCK-TYPES, $SQL-POS-OPERATIONS,
        $SQL-POSITIONED-STATEMENTS, $SQL-BOOKMARK-PERSISTENCE,
        $SQL-STATIC-SENSITIVITY, $SQL-FILE-USAGE, $SQL-COLUMN-ALIAS,
        $SQL-GROUP-BY, $SQL-KEYWORDS, $SQL-OWNER-USAGE, $SQL-QUALIFIER-USAGE,
        $SQL-QUOTED-IDENTIFIER-CASE, $SQL-SUBQUERIES, $SQL-UNION,
        $SQL-MAX-ROW-SIZE-INCLUDES-LONG, $SQL-MAX-CHAR-LITERAL-LEN,
        $SQL-TIMEDATE-ADD-INTERVALS, $SQL-TIMEDATE-DIFF-INTERVALS,
        $SQL-NEED-LONG-DATA-LEN, $SQL-MAX-BINARY-LITERAL-LEN,
        $SQL-LIKE-ESCAPE-CLAUSE, $SQL-QUALIFIER-LOCATION, $SQL-INFO-LAST,
        $SQL-INFO-DRIVER-START, $SQL-ACTIVE-ENVIRONMENTS, $SQL-ALTER-DOMAIN,
        $SQL-DATETIME-LITERALS, $SQL-BATCH-ROW-COUNT, $SQL-BATCH-SUPPORT,
        $SQL-CATALOG-LOCATION, $SQL-CATALOG-NAME-SEPARATOR,
        $SQL-CATALOG-TERM, $SQL-CATALOG-USAGE, $SQL-CONVERT-WCHAR,
        $SQL-CONVERT-INTERVAL-DAY-TIME, $SQL-CONVERT-INTERVAL-YEAR-MONTH,
        $SQL-CONVERT-WLONGVARCHAR, $SQL-CONVERT-WVARCHAR,
        $SQL-CREATE-ASSERTION, $SQL-CREATE-CHARACTER-SET,
        $SQL-CREATE-COLLATION, $SQL-CREATE-DOMAIN, $SQL-CREATE-SCHEMA,
        $SQL-CREATE-TABLE, $SQL-CREATE-TRANSLATION, $SQL-CREATE-VIEW,
        $SQL-DRIVER-HDESC, $SQL-DROP-ASSERTION, $SQL-DROP-CHARACTER-SET,
        $SQL-DROP-COLLATION, $SQL-DROP-DOMAIN, $SQL-DROP-SCHEMA,
        $SQL-DROP-TABLE, $SQL-DROP-TRANSLATION, $SQL-DROP-VIEW,
        $SQL-DYNAMIC-CURSOR-ATTRIBUTES1, $SQL-DYNAMIC-CURSOR-ATTRIBUTES2,
        $SQL-FORWARD-ONLY-CURSOR-ATTRIBUTES1,
        $SQL-FORWARD-ONLY-CURSOR-ATTRIBUTES2, $SQL-INDEX-KEYWORDS,
        $SQL-INFO-SCHEMA-VIEWS, $SQL-KEYSET-CURSOR-ATTRIBUTES1,
        $SQL-KEYSET-CURSOR-ATTRIBUTES2, $SQL-ODBC-INTERFACE-CONFORMANCE,
        $SQL-PARAM-ARRAY-ROW-COUNTS, $SQL-PARAM-ARRAY-SELECTS,
        $SQL-SCHEMA-TERM, $SQL-SCHEMA-USAGE, $SQL-SQL92-DATETIME-FUNCTIONS,
        $SQL-SQL92-FOREIGN-KEY-DELETE-RULE,
        $SQL-SQL92-FOREIGN-KEY-UPDATE-RULE, $SQL-SQL92-GRANT,
        $SQL-SQL92-NUMERIC-VALUE-FUNCTIONS, $SQL-SQL92-PREDICATES,
        $SQL-SQL92-RELATIONAL-JOIN-OPERATORS, $SQL-SQL92-REVOKE,
        $SQL-SQL92-ROW-VALUE-CONSTRUCTOR, $SQL-SQL92-STRING-FUNCTIONS,
        $SQL-SQL92-VALUE-EXPRESSIONS, $SQL-STANDARD-CLI-CONFORMANCE,
        $SQL-STATIC-CURSOR-ATTRIBUTES1, $SQL-STATIC-CURSOR-ATTRIBUTES2,
        $SQL-DDL-INDEX, $SQL-DM-VER, $SQL-INSERT-STATEMENT,
        $SQL-UNION-STATEMENT, $SQL-AT-ADD-COLUMN-SINGLE,
        $SQL-AT-ADD-COLUMN-DEFAULT, $SQL-AT-ADD-COLUMN-COLLATION,
        $SQL-AT-SET-COLUMN-DEFAULT, $SQL-AT-DROP-COLUMN-DEFAULT,
        $SQL-AT-DROP-COLUMN-CASCADE, $SQL-AT-DROP-COLUMN-RESTRICT,
        $SQL-AT-ADD-TABLE-CONSTRAINT, $SQL-AT-DROP-TABLE-CONSTRAINT-CASCADE,
        $SQL-AT-DROP-TABLE-CONSTRAINT-RESTRICT,
        $SQL-AT-CONSTRAINT-NAME-DEFINITION,
        $SQL-AT-CONSTRAINT-INITIALLY-DEFERRED,
        $SQL-AT-CONSTRAINT-INITIALLY-IMMEDIATE,
        $SQL-AT-CONSTRAINT-DEFERRABLE, $SQL-AT-CONSTRAINT-NON-DEFERRABLE,
        $SQL-CVT-CHAR, $SQL-CVT-NUMERIC, $SQL-CVT-DECIMAL, $SQL-CVT-INTEGER,
        $SQL-CVT-SMALLINT, $SQL-CVT-FLOAT, $SQL-CVT-REAL, $SQL-CVT-DOUBLE,
        $SQL-CVT-VARCHAR, $SQL-CVT-LONGVARCHAR, $SQL-CVT-BINARY,
        $SQL-CVT-VARBINARY, $SQL-CVT-BIT, $SQL-CVT-TINYINT, $SQL-CVT-BIGINT,
        $SQL-CVT-DATE, $SQL-CVT-TIME, $SQL-CVT-TIMESTAMP,
        $SQL-CVT-LONGVARBINARY, $SQL-CVT-INTERVAL-YEAR-MONTH,
        $SQL-CVT-INTERVAL-DAY-TIME, $SQL-CVT-WCHAR, $SQL-CVT-WLONGVARCHAR,
        $SQL-CVT-WVARCHAR, $SQL-FN-CVT-CONVERT, $SQL-FN-CVT-CAST,
        $SQL-FN-STR-CONCAT, $SQL-FN-STR-INSERT, $SQL-FN-STR-LEFT,
        $SQL-FN-STR-LTRIM, $SQL-FN-STR-LENGTH, $SQL-FN-STR-LOCATE,
        $SQL-FN-STR-LCASE, $SQL-FN-STR-REPEAT, $SQL-FN-STR-REPLACE,
        $SQL-FN-STR-RIGHT, $SQL-FN-STR-RTRIM, $SQL-FN-STR-SUBSTRING,
        $SQL-FN-STR-UCASE, $SQL-FN-STR-ASCII, $SQL-FN-STR-CHAR,
        $SQL-FN-STR-DIFFERENCE, $SQL-FN-STR-LOCATE-2, $SQL-FN-STR-SOUNDEX,
        $SQL-FN-STR-SPACE, $SQL-FN-STR-BIT-LENGTH, $SQL-FN-STR-CHAR-LENGTH,
        $SQL-FN-STR-CHARACTER-LENGTH, $SQL-FN-STR-OCTET-LENGTH,
        $SQL-FN-STR-POSITION, $SQL-SSF-CONVERT, $SQL-SSF-LOWER,
        $SQL-SSF-UPPER, $SQL-SSF-SUBSTRING, $SQL-SSF-TRANSLATE,
        $SQL-SSF-TRIM-BOTH, $SQL-SSF-TRIM-LEADING, $SQL-SSF-TRIM-TRAILING,
        $SQL-FN-NUM-ABS, $SQL-FN-NUM-ACOS, $SQL-FN-NUM-ASIN,
        $SQL-FN-NUM-ATAN, $SQL-FN-NUM-ATAN2, $SQL-FN-NUM-CEILING,
        $SQL-FN-NUM-COS, $SQL-FN-NUM-COT, $SQL-FN-NUM-EXP, $SQL-FN-NUM-FLOOR,
        $SQL-FN-NUM-LOG, $SQL-FN-NUM-MOD, $SQL-FN-NUM-SIGN, $SQL-FN-NUM-SIN,
        $SQL-FN-NUM-SQRT, $SQL-FN-NUM-TAN, $SQL-FN-NUM-PI, $SQL-FN-NUM-RAND,
        $SQL-FN-NUM-DEGREES, $SQL-FN-NUM-LOG10, $SQL-FN-NUM-POWER,
        $SQL-FN-NUM-RADIANS, $SQL-FN-NUM-ROUND, $SQL-FN-NUM-TRUNCATE,
        $SQL-SNVF-BIT-LENGTH, $SQL-SNVF-CHAR-LENGTH,
        $SQL-SNVF-CHARACTER-LENGTH, $SQL-SNVF-EXTRACT,
        $SQL-SNVF-OCTET-LENGTH, $SQL-SNVF-POSITION, $SQL-FN-TD-NOW,
        $SQL-FN-TD-CURDATE, $SQL-FN-TD-DAYOFMONTH, $SQL-FN-TD-DAYOFWEEK,
        $SQL-FN-TD-DAYOFYEAR, $SQL-FN-TD-MONTH, $SQL-FN-TD-QUARTER,
        $SQL-FN-TD-WEEK, $SQL-FN-TD-YEAR, $SQL-FN-TD-CURTIME,
        $SQL-FN-TD-HOUR, $SQL-FN-TD-MINUTE, $SQL-FN-TD-SECOND,
        $SQL-FN-TD-TIMESTAMPADD, $SQL-FN-TD-TIMESTAMPDIFF,
        $SQL-FN-TD-DAYNAME, $SQL-FN-TD-MONTHNAME, $SQL-FN-TD-CURRENT-DATE,
        $SQL-FN-TD-CURRENT-TIME, $SQL-FN-TD-CURRENT-TIMESTAMP,
        $SQL-FN-TD-EXTRACT, $SQL-SDF-CURRENT-DATE, $SQL-SDF-CURRENT-TIME,
        $SQL-SDF-CURRENT-TIMESTAMP, $SQL-FN-SYS-USERNAME, $SQL-FN-SYS-DBNAME,
        $SQL-FN-SYS-IFNULL, $SQL-FN-TSI-FRAC-SECOND, $SQL-FN-TSI-SECOND,
        $SQL-FN-TSI-MINUTE, $SQL-FN-TSI-HOUR, $SQL-FN-TSI-DAY,
        $SQL-FN-TSI-WEEK, $SQL-FN-TSI-MONTH, $SQL-FN-TSI-QUARTER,
        $SQL-FN-TSI-YEAR, $SQL-CA1-NEXT, $SQL-CA1-ABSOLUTE,
        $SQL-CA1-RELATIVE, $SQL-CA1-BOOKMARK, $SQL-CA1-LOCK-NO-CHANGE,
        $SQL-CA1-LOCK-EXCLUSIVE, $SQL-CA1-LOCK-UNLOCK, $SQL-CA1-POS-POSITION,
        $SQL-CA1-POS-UPDATE, $SQL-CA1-POS-DELETE, $SQL-CA1-POS-REFRESH,
        $SQL-CA1-POSITIONED-UPDATE, $SQL-CA1-POSITIONED-DELETE,
        $SQL-CA1-SELECT-FOR-UPDATE, $SQL-CA1-BULK-ADD,
        $SQL-CA1-BULK-UPDATE-BY-BOOKMARK, $SQL-CA1-BULK-DELETE-BY-BOOKMARK,
        $SQL-CA1-BULK-FETCH-BY-BOOKMARK, $SQL-CA2-READ-ONLY-CONCURRENCY,
        $SQL-CA2-LOCK-CONCURRENCY, $SQL-CA2-OPT-ROWVER-CONCURRENCY,
        $SQL-CA2-OPT-VALUES-CONCURRENCY, $SQL-CA2-SENSITIVITY-ADDITIONS,
        $SQL-CA2-SENSITIVITY-DELETIONS, $SQL-CA2-SENSITIVITY-UPDATES,
        $SQL-CA2-MAX-ROWS-SELECT, $SQL-CA2-MAX-ROWS-INSERT,
        $SQL-CA2-MAX-ROWS-DELETE, $SQL-CA2-MAX-ROWS-UPDATE,
        $SQL-CA2-MAX-ROWS-CATALOG, $SQL-CA2-MAX-ROWS-AFFECTS-ALL,
        $SQL-CA2-CRC-EXACT, $SQL-CA2-CRC-APPROXIMATE,
        $SQL-CA2-SIMULATE-NON-UNIQUE, $SQL-CA2-SIMULATE-TRY-UNIQUE,
        $SQL-CA2-SIMULATE-UNIQUE, $SQL-OAC-NONE, $SQL-OAC-LEVEL1,
        $SQL-OAC-LEVEL2, $SQL-OSCC-NOT-COMPLIANT, $SQL-OSCC-COMPLIANT,
        $SQL-OSC-MINIMUM, $SQL-OSC-CORE, $SQL-OSC-EXTENDED, $SQL-CB-NULL,
        $SQL-CB-NON-NULL, $SQL-SO-FORWARD-ONLY, $SQL-SO-KEYSET-DRIVEN,
        $SQL-SO-DYNAMIC, $SQL-SO-MIXED, $SQL-SO-STATIC, $SQL-FD-FETCH-RESUME,
        $SQL-TXN-VERSIONING, $SQL-CN-NONE, $SQL-CN-DIFFERENT, $SQL-CN-ANY,
        $SQL-NNC-NULL, $SQL-NNC-NON-NULL, $SQL-NC-START, $SQL-NC-END,
        $SQL-FILE-NOT-SUPPORTED, $SQL-FILE-TABLE, $SQL-FILE-QUALIFIER,
        $SQL-FILE-CATALOG, $SQL-GD-BLOCK, $SQL-GD-BOUND,
        $SQL-PS-POSITIONED-DELETE, $SQL-PS-POSITIONED-UPDATE,
        $SQL-PS-SELECT-FOR-UPDATE, $SQL-GB-NOT-SUPPORTED,
        $SQL-GB-GROUP-BY-EQUALS-SELECT, $SQL-GB-GROUP-BY-CONTAINS-SELECT,
        $SQL-GB-NO-RELATION, $SQL-GB-COLLATE, $SQL-OU-DML-STATEMENTS,
        $SQL-OU-PROCEDURE-INVOCATION, $SQL-OU-TABLE-DEFINITION,
        $SQL-OU-INDEX-DEFINITION, $SQL-OU-PRIVILEGE-DEFINITION,
        $SQL-SU-DML-STATEMENTS, $SQL-SU-PROCEDURE-INVOCATION,
        $SQL-SU-TABLE-DEFINITION, $SQL-SU-INDEX-DEFINITION,
        $SQL-SU-PRIVILEGE-DEFINITION, $SQL-QU-DML-STATEMENTS,
        $SQL-QU-PROCEDURE-INVOCATION, $SQL-QU-TABLE-DEFINITION,
        $SQL-QU-INDEX-DEFINITION, $SQL-QU-PRIVILEGE-DEFINITION,
        $SQL-CU-DML-STATEMENTS, $SQL-CU-PROCEDURE-INVOCATION,
        $SQL-CU-TABLE-DEFINITION, $SQL-CU-INDEX-DEFINITION,
        $SQL-CU-PRIVILEGE-DEFINITION, $SQL-SQ-COMPARISON, $SQL-SQ-EXISTS,
        $SQL-SQ-IN, $SQL-SQ-QUANTIFIED, $SQL-SQ-CORRELATED-SUBQUERIES,
        $SQL-U-UNION, $SQL-U-UNION-ALL, $SQL-BP-CLOSE, $SQL-BP-DELETE,
        $SQL-BP-DROP, $SQL-BP-TRANSACTION, $SQL-BP-UPDATE,
        $SQL-BP-OTHER-HSTMT, $SQL-BP-SCROLL, $SQL-SS-ADDITIONS,
        $SQL-SS-DELETIONS, $SQL-SS-UPDATES, $SQL-CV-CREATE-VIEW,
        $SQL-CV-CHECK-OPTION, $SQL-CV-CASCADED, $SQL-CV-LOCAL,
        $SQL-LCK-NO-CHANGE, $SQL-LCK-EXCLUSIVE, $SQL-LCK-UNLOCK,
        $SQL-POS-POSITION, $SQL-POS-REFRESH, $SQL-POS-UPDATE,
        $SQL-POS-DELETE, $SQL-POS-ADD, $SQL-QL-START, $SQL-QL-END,
        $SQL-AF-AVG, $SQL-AF-COUNT, $SQL-AF-MAX, $SQL-AF-MIN, $SQL-AF-SUM,
        $SQL-AF-DISTINCT, $SQL-AF-ALL, $SQL-SC-SQL92-ENTRY,
        $SQL-SC-FIPS127-2-TRANSITIONAL, $SQL-SC-SQL92-INTERMEDIATE,
        $SQL-SC-SQL92-FULL, $SQL-DL-SQL92-DATE, $SQL-DL-SQL92-TIME,
        $SQL-DL-SQL92-TIMESTAMP, $SQL-DL-SQL92-INTERVAL-YEAR,
        $SQL-DL-SQL92-INTERVAL-MONTH, $SQL-DL-SQL92-INTERVAL-DAY,
        $SQL-DL-SQL92-INTERVAL-HOUR, $SQL-DL-SQL92-INTERVAL-MINUTE,
        $SQL-DL-SQL92-INTERVAL-SECOND, $SQL-DL-SQL92-INTERVAL-YEAR-TO-MONTH,
        $SQL-DL-SQL92-INTERVAL-DAY-TO-HOUR,
        $SQL-DL-SQL92-INTERVAL-DAY-TO-MINUTE,
        $SQL-DL-SQL92-INTERVAL-DAY-TO-SECOND,
        $SQL-DL-SQL92-INTERVAL-HOUR-TO-MINUTE,
        $SQL-DL-SQL92-INTERVAL-HOUR-TO-SECOND,
        $SQL-DL-SQL92-INTERVAL-MINUTE-TO-SECOND, $SQL-CL-START, $SQL-CL-END,
        $SQL-BRC-PROCEDURES, $SQL-BRC-EXPLICIT, $SQL-BRC-ROLLED-UP,
        $SQL-BS-SELECT-EXPLICIT, $SQL-BS-ROW-COUNT-EXPLICIT,
        $SQL-BS-SELECT-PROC, $SQL-BS-ROW-COUNT-PROC, $SQL-PARC-BATCH,
        $SQL-PARC-NO-BATCH, $SQL-PAS-BATCH, $SQL-PAS-NO-BATCH,
        $SQL-PAS-NO-SELECT, $SQL-IK-NONE, $SQL-IK-ASC, $SQL-IK-DESC,
        $SQL-IK-ALL, $SQL-ISV-ASSERTIONS, $SQL-ISV-CHARACTER-SETS,
        $SQL-ISV-CHECK-CONSTRAINTS, $SQL-ISV-COLLATIONS,
        $SQL-ISV-COLUMN-DOMAIN-USAGE, $SQL-ISV-COLUMN-PRIVILEGES,
        $SQL-ISV-COLUMNS, $SQL-ISV-CONSTRAINT-COLUMN-USAGE,
        $SQL-ISV-CONSTRAINT-TABLE-USAGE, $SQL-ISV-DOMAIN-CONSTRAINTS,
        $SQL-ISV-DOMAINS, $SQL-ISV-KEY-COLUMN-USAGE,
        $SQL-ISV-REFERENTIAL-CONSTRAINTS, $SQL-ISV-SCHEMATA,
        $SQL-ISV-SQL-LANGUAGES, $SQL-ISV-TABLE-CONSTRAINTS,
        $SQL-ISV-TABLE-PRIVILEGES, $SQL-ISV-TABLES, $SQL-ISV-TRANSLATIONS,
        $SQL-ISV-USAGE-PRIVILEGES, $SQL-ISV-VIEW-COLUMN-USAGE,
        $SQL-ISV-VIEW-TABLE-USAGE, $SQL-ISV-VIEWS, $SQL-AM-NONE,
        $SQL-AM-CONNECTION, $SQL-AM-STATEMENT,
        $SQL-AD-CONSTRAINT-NAME-DEFINITION, $SQL-AD-ADD-DOMAIN-CONSTRAINT,
        $SQL-AD-DROP-DOMAIN-CONSTRAINT, $SQL-AD-ADD-DOMAIN-DEFAULT,
        $SQL-AD-DROP-DOMAIN-DEFAULT,
        $SQL-AD-ADD-CONSTRAINT-INITIALLY-DEFERRED,
        $SQL-AD-ADD-CONSTRAINT-INITIALLY-IMMEDIATE,
        $SQL-AD-ADD-CONSTRAINT-DEFERRABLE,
        $SQL-AD-ADD-CONSTRAINT-NON-DEFERRABLE, $SQL-CS-CREATE-SCHEMA,
        $SQL-CS-AUTHORIZATION, $SQL-CS-DEFAULT-CHARACTER-SET,
        $SQL-CTR-CREATE-TRANSLATION, $SQL-CA-CREATE-ASSERTION,
        $SQL-CA-CONSTRAINT-INITIALLY-DEFERRED,
        $SQL-CA-CONSTRAINT-INITIALLY-IMMEDIATE,
        $SQL-CA-CONSTRAINT-DEFERRABLE, $SQL-CA-CONSTRAINT-NON-DEFERRABLE,
        $SQL-CCS-CREATE-CHARACTER-SET, $SQL-CCS-COLLATE-CLAUSE,
        $SQL-CCS-LIMITED-COLLATION, $SQL-CCOL-CREATE-COLLATION,
        $SQL-CDO-CREATE-DOMAIN, $SQL-CDO-DEFAULT, $SQL-CDO-CONSTRAINT,
        $SQL-CDO-COLLATION, $SQL-CDO-CONSTRAINT-NAME-DEFINITION,
        $SQL-CDO-CONSTRAINT-INITIALLY-DEFERRED,
        $SQL-CDO-CONSTRAINT-INITIALLY-IMMEDIATE,
        $SQL-CDO-CONSTRAINT-DEFERRABLE, $SQL-CDO-CONSTRAINT-NON-DEFERRABLE,
        $SQL-CT-CREATE-TABLE, $SQL-CT-COMMIT-PRESERVE, $SQL-CT-COMMIT-DELETE,
        $SQL-CT-GLOBAL-TEMPORARY, $SQL-CT-LOCAL-TEMPORARY,
        $SQL-CT-CONSTRAINT-INITIALLY-DEFERRED,
        $SQL-CT-CONSTRAINT-INITIALLY-IMMEDIATE,
        $SQL-CT-CONSTRAINT-DEFERRABLE, $SQL-CT-CONSTRAINT-NON-DEFERRABLE,
        $SQL-CT-COLUMN-CONSTRAINT, $SQL-CT-COLUMN-DEFAULT,
        $SQL-CT-COLUMN-COLLATION, $SQL-CT-TABLE-CONSTRAINT,
        $SQL-CT-CONSTRAINT-NAME-DEFINITION, $SQL-DI-CREATE-INDEX,
        $SQL-DI-DROP-INDEX, $SQL-DC-DROP-COLLATION, $SQL-DD-DROP-DOMAIN,
        $SQL-DD-RESTRICT, $SQL-DD-CASCADE, $SQL-DS-DROP-SCHEMA,
        $SQL-DS-RESTRICT, $SQL-DS-CASCADE, $SQL-DCS-DROP-CHARACTER-SET,
        $SQL-DA-DROP-ASSERTION, $SQL-DT-DROP-TABLE, $SQL-DT-RESTRICT,
        $SQL-DT-CASCADE, $SQL-DTR-DROP-TRANSLATION, $SQL-DV-DROP-VIEW,
        $SQL-DV-RESTRICT, $SQL-DV-CASCADE, $SQL-IS-INSERT-LITERALS,
        $SQL-IS-INSERT-SEARCHED, $SQL-IS-SELECT-INTO, $SQL-OIC-CORE,
        $SQL-OIC-LEVEL1, $SQL-OIC-LEVEL2, $SQL-SFKD-CASCADE,
        $SQL-SFKD-NO-ACTION, $SQL-SFKD-SET-DEFAULT, $SQL-SFKD-SET-NULL,
        $SQL-SFKU-CASCADE, $SQL-SFKU-NO-ACTION, $SQL-SFKU-SET-DEFAULT,
        $SQL-SFKU-SET-NULL, $SQL-SG-USAGE-ON-DOMAIN,
        $SQL-SG-USAGE-ON-CHARACTER-SET, $SQL-SG-USAGE-ON-COLLATION,
        $SQL-SG-USAGE-ON-TRANSLATION, $SQL-SG-WITH-GRANT-OPTION,
        $SQL-SG-DELETE-TABLE, $SQL-SG-INSERT-TABLE, $SQL-SG-INSERT-COLUMN,
        $SQL-SG-REFERENCES-TABLE, $SQL-SG-REFERENCES-COLUMN,
        $SQL-SG-SELECT-TABLE, $SQL-SG-UPDATE-TABLE, $SQL-SG-UPDATE-COLUMN,
        $SQL-SP-EXISTS, $SQL-SP-ISNOTNULL, $SQL-SP-ISNULL,
        $SQL-SP-MATCH-FULL, $SQL-SP-MATCH-PARTIAL, $SQL-SP-MATCH-UNIQUE-FULL,
        $SQL-SP-MATCH-UNIQUE-PARTIAL, $SQL-SP-OVERLAPS, $SQL-SP-UNIQUE,
        $SQL-SP-LIKE, $SQL-SP-IN, $SQL-SP-BETWEEN, $SQL-SP-COMPARISON,
        $SQL-SP-QUANTIFIED-COMPARISON, $SQL-SRJO-CORRESPONDING-CLAUSE,
        $SQL-SRJO-CROSS-JOIN, $SQL-SRJO-EXCEPT-JOIN,
        $SQL-SRJO-FULL-OUTER-JOIN, $SQL-SRJO-INNER-JOIN,
        $SQL-SRJO-INTERSECT-JOIN, $SQL-SRJO-LEFT-OUTER-JOIN,
        $SQL-SRJO-NATURAL-JOIN, $SQL-SRJO-RIGHT-OUTER-JOIN,
        $SQL-SRJO-UNION-JOIN, $SQL-SR-USAGE-ON-DOMAIN,
        $SQL-SR-USAGE-ON-CHARACTER-SET, $SQL-SR-USAGE-ON-COLLATION,
        $SQL-SR-USAGE-ON-TRANSLATION, $SQL-SR-GRANT-OPTION-FOR,
        $SQL-SR-CASCADE, $SQL-SR-RESTRICT, $SQL-SR-DELETE-TABLE,
        $SQL-SR-INSERT-TABLE, $SQL-SR-INSERT-COLUMN,
        $SQL-SR-REFERENCES-TABLE, $SQL-SR-REFERENCES-COLUMN,
        $SQL-SR-SELECT-TABLE, $SQL-SR-UPDATE-TABLE, $SQL-SR-UPDATE-COLUMN,
        $SQL-SRVC-VALUE-EXPRESSION, $SQL-SRVC-NULL, $SQL-SRVC-DEFAULT,
        $SQL-SRVC-ROW-SUBQUERY, $SQL-SVE-CASE, $SQL-SVE-CAST,
        $SQL-SVE-COALESCE, $SQL-SVE-NULLIF, $SQL-SCC-XOPEN-CLI-VERSION1,
        $SQL-SCC-ISO92-CLI, $SQL-US-UNION, $SQL-US-UNION-ALL,
        $SQL-FETCH-FIRST-USER, $SQL-FETCH-FIRST-SYSTEM, $SQL-ENTIRE-ROWSET,
        $SQL-UPDATE, $SQL-DELETE, $SQL-ADD, $SQL-SETPOS-MAX-OPTION-VALUE,
        $SQL-UPDATE-BY-BOOKMARK, $SQL-DELETE-BY-BOOKMARK,
        $SQL-FETCH-BY-BOOKMARK, $SQL-LOCK-UNLOCK, $SQL-BEST-ROWID,
        $SQL-ROWVER, $SQL-PC-NOT-PSEUDO, $SQL-QUICK, $SQL-ENSURE,
        $SQL-TABLE-STAT, $SQL-DRIVER-NOPROMPT, $SQL-DRIVER-COMPLETE,
        $SQL-DRIVER-PROMPT, $SQL-DRIVER-COMPLETE-REQUIRED, 
        $SQL-FETCH-BOOKMARK, $SQL-ROW-SUCCESS, $SQL-ROW-DELETED,
        $SQL-ROW-UPDATED, $SQL-ROW-NOROW, $SQL-ROW-ADDED, $SQL-ROW-ERROR,
        $SQL-ROW-SUCCESS-WITH-INFO, $SQL-ROW-PROCEED, $SQL-ROW-IGNORE,
        $SQL-PARAM-SUCCESS, $SQL-PARAM-SUCCESS-WITH-INFO, $SQL-PARAM-ERROR,
        $SQL-PARAM-UNUSED, $SQL-PARAM-DIAG-UNAVAILABLE, $SQL-PARAM-IGNORE,
        $SQL-CASCADE, $SQL-RESTRICT, $SQL-SET-NULL, $SQL-NO-ACTION,
        $SQL-SET-DEFAULT, $SQL-INITIALLY-DEFERRED, $SQL-INITIALLY-IMMEDIATE,
        $SQL-PARAM-TYPE-UNKNOWN, $SQL-PARAM-INPUT, $SQL-PARAM-INPUT-OUTPUT,
        $SQL-RESULT-COL, $SQL-PARAM-OUTPUT, $SQL-RETURN-VALUE,
        $SQL-PT-UNKNOWN, $SQL-PT-PROCEDURE, $SQL-PT-FUNCTION,
        $SQL-YEAR, $SQL-MONTH, $SQL-DAY, $SQL-HOUR, $SQL-MINUTE, $SQL-SECOND,
        $SQL-YEAR-TO-MONTH, $SQL-DAY-TO-HOUR, $SQL-DAY-TO-MINUTE,
        $SQL-DAY-TO-SECOND, $SQL-HOUR-TO-MINUTE, $SQL-HOUR-TO-SECOND,
        $SQL-MINUTE-TO-SECOND, $SQL-FD-FETCH-PREV,
        $SQL-FETCH-PREV, $SQL-CONCUR-TIMESTAMP, $SQL-SCCO-OPT-TIMESTAMP,
        $SQL-CC-DELETE, $SQL-CR-DELETE, $SQL-CC-CLOSE, $SQL-CR-CLOSE,
        $SQL-CC-PRESERVE, $SQL-CR-PRESERVE, $SQL-FETCH-RESUME,
  // from "sqltypes.h":
        $ODBCVER, 
        $SQL-MAX-NUMERIC-LEN,
  // from "sqlucode.h":
        $SQL-WVARCHAR, $SQL-WLONGVARCHAR, $SQL-C-WCHAR, $SQL-C-TCHAR,
        $SQL-C-TCHAR,
  // from "w16macro.h":
        $WM-CTLCOLOREDIT, $WM-CTLCOLORLISTBOX, $WM-CTLCOLORBTN,
        $WM-CTLCOLORDLG, $WM-CTLCOLORSCROLLBAR, $WM-CTLCOLORSTATIC;


  // from "sqltypes.j":
  export <SQLCHAR>, <SQLDATE>, <SQLDECIMAL>, <SQLDOUBLE>, <SQLFLOAT>,
	<SQLINTEGER>, <SQLUINTEGER>, <SQLNUMERIC>, <SQLPOINTER>, <SQLREAL>,
	<SQLSMALLINT>, <SQLUSMALLINT>, <SQLTIME>, <SQLTIMESTAMP>,
	<SQLVARCHAR>, <SQLRETURN>, <SQLHANDLE>, <SQLHENV>, <SQLHDBC>,
	<SQLHSTMT>, <SQLHDESC>, <UCHAR>, <SQLSCHAR>, <SDWORD>, <SWORD>,
	<SQLUINTEGER>, <ULONG>, <USHORT>, <SDOUBLE>, <LDOUBLE>, <SFLOAT>,
	<PTR>, <HENV>, <HDBC>, <HSTMT>, <SQLHWND>, year-value,
	year-value-setter, month-value, month-value-setter, day-value,
	day-value-setter, <DATE-STRUCT>, <LPDATE-STRUCT>, <SQL-DATE-STRUCT>,
	hour-value, hour-value-setter, minute-value, minute-value-setter,
	second-value, second-value-setter, <TIME-STRUCT>, <LPTIME-STRUCT>,
	<SQL-TIME-STRUCT>, year-value, year-value-setter, month-value,
	month-value-setter, day-value, day-value-setter, hour-value,
	hour-value-setter, minute-value, minute-value-setter, second-value,
	second-value-setter, fraction-value, fraction-value-setter,
	<TIMESTAMP-STRUCT>, <LPTIMESTAMP-STRUCT>, <SQL-TIMESTAMP-STRUCT>,
	$SQL-IS-YEAR, $SQL-IS-MONTH, $SQL-IS-DAY, $SQL-IS-HOUR,
	$SQL-IS-MINUTE, $SQL-IS-SECOND, $SQL-IS-YEAR-TO-MONTH,
	$SQL-IS-DAY-TO-HOUR, $SQL-IS-DAY-TO-MINUTE, $SQL-IS-DAY-TO-SECOND,
	$SQL-IS-HOUR-TO-MINUTE, $SQL-IS-HOUR-TO-SECOND,
	$SQL-IS-MINUTE-TO-SECOND, year-value, year-value-setter, month-value,
	month-value-setter, <SQL-YEAR-MONTH-STRUCT>,
	<LPSQL-YEAR-MONTH-STRUCT>, day-value, day-value-setter, hour-value,
	hour-value-setter, minute-value, minute-value-setter, second-value,
	second-value-setter, fraction-value, fraction-value-setter,
	<SQL-DAY-SECOND-STRUCT>, <LPSQL-DAY-SECOND-STRUCT>,
	interval-type-value, interval-type-value-setter, interval-sign-value,
	interval-sign-value-setter, year-month-value,
	year-month-value-setter, day-second-value, day-second-value-setter,
	intval-value, intval-value-setter, <SQL-INTERVAL-STRUCT>,
	<LPSQL-INTERVAL-STRUCT>, precision-value, precision-value-setter,
	scale-value, scale-value-setter, sign-value, sign-value-setter,
	val-array, val-array-setter, val-value, <SQL-NUMERIC-STRUCT>,
        <LPSQL-NUMERIC-STRUCT>, <SQLWCHAR>, <SQLTCHAR>,
        <lpsqlhstmt>, <lpsqlhdbc>, <lpsqlhenv>, <lpsqluinteger>,
        <lpsqlhandle>, <lpsqlinteger>, <lpsqlpointer>, <lpsqlusmallint>;

  // from "sql.j":
  export SQLAllocConnect, SQLAllocEnv, SQLAllocHandle, SQLAllocStmt,
	SQLBindCol, SQLBindParam, SQLCancel, SQLCloseCursor, SQLColAttribute,
	SQLColumns, SQLConnect, SQLCopyDesc, SQLDataSources, SQLDescribeCol,
	SQLDisconnect, SQLEndTran, SQLError, SQLExecDirect, SQLExecute,
	SQLFetch, SQLFetchScroll, SQLFreeConnect, SQLFreeEnv, SQLFreeHandle,
	SQLFreeStmt, SQLGetConnectAttr, SQLGetConnectOption,
	SQLGetCursorName, SQLGetData, SQLGetDescField, SQLGetDescRec,
	SQLGetDiagField, SQLGetDiagRec, SQLGetEnvAttr, SQLGetFunctions,
	SQLGetInfo, SQLGetStmtAttr, SQLGetStmtOption, SQLGetTypeInfo,
	SQLNumResultCols, SQLParamData, SQLPrepare, SQLPutData, SQLRowCount,
	SQLSetConnectAttr, SQLSetConnectOption, SQLSetCursorName,
	SQLSetDescField, SQLSetDescRec, SQLSetEnvAttr, SQLSetParam,
	SQLSetStmtAttr, SQLSetStmtOption, SQLSpecialColumns, SQLStatistics,
	SQLTables, SQLTransact;


  // from "sqlext.j":
  export SQLDriverConnect, SQLBrowseConnect, SQLBulkOperations,
	SQLColAttributes, SQLColumnPrivileges, SQLDescribeParam,
	SQLExtendedFetch, SQLForeignKeys, SQLMoreResults, SQLNativeSql,
	SQLNumParams, SQLParamOptions, SQLPrimaryKeys, SQLProcedureColumns,
        SQLProcedures, SQLSetPos, SQLTablePrivileges, SQLDrivers,
        SQLBindParameter, SQLAllocHandleStd, SQLSetScrollOptions;

  // from "fixup.h":
  export $SQL-SPEC-MAJOR, $SQL-SPEC-MINOR, $SQL-SQLSTATE-SIZE,
	$SQL-MAX-DSN-LENGTH, $SQL-ASYNC-ENABLE, $SQL-GET-BOOKMARK,
	$SQL-ROW-NUMBER, $SQL-ATTR-ROW-NUMBER, $SQL-NOSCAN-ON,
	$SQL-BIND-TYPE-DEFAULT, $SQL-CONCUR-DEFAULT,
        $SQL-CURSOR-TYPE-DEFAULT, $SQL-C-CHAR, $SQL-C-LONG, $SQL-C-SHORT,
        $SQL-C-SSHORT, $SQL-C-STINYINT, $SQL-C-ULONG, $SQL-C-USHORT,
        $SQL-C-UTINYINT, $SQL-C-SLONG,
	$SQL-C-FLOAT, $SQL-C-DOUBLE, $SQL-C-BOOKMARK, $SQL-API-ALL-FUNCTIONS,
	$SQL-API-LOADBYORDINAL, $SQL-API-ODBC3-ALL-FUNCTIONS-SIZE,
	$SQL-ACTIVE-CONNECTIONS, $SQL-ACTIVE-STATEMENTS,
	$SQL-MAX-OWNER-NAME-LEN, $SQL-MAX-QUALIFIER-NAME-LEN,
	$SQL-ODBC-SQL-OPT-IEF, $SQL-OJ-CAPABILITIES, $SQL-ASYNC-MODE,
	$SQL-MAX-ASYNC-CONCURRENT-STATEMENTS, $SQL-POSITION, $SQL-REFRESH,
	$SQL-LOCK-NO-CHANGE, $SQL-LOCK-EXCLUSIVE, $SQL-DATABASE-NAME,
    $SQL-SCROLL-FORWARD-ONLY, $SQL-SCROLL-KEYSET-DRIVEN,
    $SQL-SCROLL-DYNAMIC, $SQL-SCROLL-STATIC, $SQL-SPEC-STRING;

  export $SQL-ALL-CATALOGS, $SQL-ALL-SCHEMAS, $SQL-ALL-TABLE-TYPES, $SQL-ALL-TABLES;
end module;
