module: remote-nub-protocol

define open abstract class Rtmgr/<AccessPath> (<object>)
end class;

define method class-typecode (class :: subclass(Rtmgr/<AccessPath>))
 => (typecode :: <object-reference-typecode>)
  Rtmgr/$AccessPath-typecode;
end method;

define method object-typecode (object :: Rtmgr/<AccessPath>)
 => (typecode :: <object-reference-typecode>)
  Rtmgr/$AccessPath-typecode;
end method;

define constant Rtmgr/$AccessPath-typecode = make(<object-reference-typecode>, type: Rtmgr/<AccessPath>, name: "AccessPath", repository-id: "IDL:functionalobjects.com/Rtmgr/AccessPath:1.0");

define constant Rtmgr/AccessPath/<NUBINT> = CORBA/<long>;

define constant Rtmgr/AccessPath/<RTARGET-ADDRESS> = CORBA/<unsigned-long>;

define constant Rtmgr/AccessPath/<RNUBPROCESS> = CORBA/<unsigned-long>;

define constant Rtmgr/AccessPath/<RNUBTHREAD> = CORBA/<unsigned-long>;

define open generic Rtmgr/AccessPath/create-thread-stop-reason-handler (object :: Rtmgr/<AccessPath>, process :: Rtmgr/AccessPath/<RNUBPROCESS>, thread :: Rtmgr/AccessPath/<RNUBTHREAD>, priority :: Rtmgr/AccessPath/<NUBINT>)
 => ();

define open generic Rtmgr/AccessPath/debugger-message (object :: Rtmgr/<AccessPath>, message :: CORBA/<string>, arg1 :: Rtmgr/AccessPath/<RTARGET-ADDRESS>, arg2 :: Rtmgr/AccessPath/<RTARGET-ADDRESS>)
 => ();

define open generic Rtmgr/AccessPath/nub-debug-message (object :: Rtmgr/<AccessPath>, message :: CORBA/<string>, arg1 :: Rtmgr/AccessPath/<RTARGET-ADDRESS>, arg2 :: Rtmgr/AccessPath/<RTARGET-ADDRESS>)
 => ();

define open generic Rtmgr/AccessPath/debugger-error (object :: Rtmgr/<AccessPath>, message :: CORBA/<string>, arg1 :: Rtmgr/AccessPath/<RTARGET-ADDRESS>, arg2 :: Rtmgr/AccessPath/<RTARGET-ADDRESS>)
 => ();

define open abstract class Rtmgr/<RemoteNub> (<object>)
end class;

define method class-typecode (class :: subclass(Rtmgr/<RemoteNub>))
 => (typecode :: <object-reference-typecode>)
  Rtmgr/$RemoteNub-typecode;
end method;

define method object-typecode (object :: Rtmgr/<RemoteNub>)
 => (typecode :: <object-reference-typecode>)
  Rtmgr/$RemoteNub-typecode;
end method;

define constant Rtmgr/$RemoteNub-typecode = make(<object-reference-typecode>, type: Rtmgr/<RemoteNub>, name: "RemoteNub", repository-id: "IDL:functionalobjects.com/Rtmgr/RemoteNub:1.0");

define constant Rtmgr/RemoteNub/<INT8> = CORBA/<char>;

define constant Rtmgr/RemoteNub/<INT16> = CORBA/<short>;

define constant Rtmgr/RemoteNub/<INT32> = CORBA/<long>;

define constant Rtmgr/RemoteNub/<UNICODE> = CORBA/<short>;

define constant Rtmgr/RemoteNub/<NUBINT> = CORBA/<long>;

define constant Rtmgr/RemoteNub/<NUB-INDEX> = CORBA/<long>;

define constant Rtmgr/RemoteNub/<NUB-ERROR> = CORBA/<long>;

define constant Rtmgr/RemoteNub/<NUBFLOAT> = CORBA/<float>;

define constant Rtmgr/RemoteNub/<NUBDOUBLE> = CORBA/<double>;

define constant Rtmgr/RemoteNub/<TARGET-INT> = CORBA/<long>;

define constant Rtmgr/RemoteNub/<RNUBHANDLE> = CORBA/<unsigned-long>;

define constant Rtmgr/RemoteNub/<RNUB> = CORBA/<unsigned-long>;

define constant Rtmgr/RemoteNub/<RSERVER> = CORBA/<unsigned-long>;

define constant Rtmgr/RemoteNub/<RNUBPROCESS> = CORBA/<unsigned-long>;

define constant Rtmgr/RemoteNub/<RNUBTHREAD> = CORBA/<unsigned-long>;

define constant Rtmgr/RemoteNub/<RNUBLIBRARY> = CORBA/<unsigned-long>;

define constant Rtmgr/RemoteNub/<RTARGET-ADDRESS> = CORBA/<unsigned-long>;

define constant Rtmgr/RemoteNub/<FLAG> = CORBA/<unsigned-long>;

define constant Rtmgr/RemoteNub/<RTARGET-ADDRESS-SEQ> = limited(CORBA/<sequence>, of: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define constant Rtmgr/RemoteNub/<STRING-SEQ> = limited(CORBA/<sequence>, of: CORBA/<string>);

define open generic Rtmgr/RemoteNub/process (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<RNUB>);

define open generic Rtmgr/RemoteNub/access-path (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/<AccessPath>);

define open generic Rtmgr/RemoteNub/create-and-debug-process (object :: Rtmgr/<RemoteNub>, command :: CORBA/<string>, args :: CORBA/<string>, path-count :: Rtmgr/RemoteNub/<NUBINT>, lib-count :: Rtmgr/RemoteNub/<NUBINT>, working-dir :: CORBA/<string>, create-shell :: Rtmgr/RemoteNub/<NUBINT>)
 => (result :: Rtmgr/RemoteNub/<RNUB>);

define open generic Rtmgr/RemoteNub/debug-active-process (object :: Rtmgr/<RemoteNub>, process-name :: CORBA/<string>, process-id :: CORBA/<string>, actual-process-id :: CORBA/<unsigned-long>, path-count :: Rtmgr/RemoteNub/<NUBINT>, jit-info :: CORBA/<string>)
 => (result :: Rtmgr/RemoteNub/<RNUB>);

define open generic Rtmgr/RemoteNub/remote-value-byte-size (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/get-process-page-fault-count (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/thread-os-priority (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/get-thread-cpu-time (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/get-library-base-address (object :: Rtmgr/<RemoteNub>, dll :: Rtmgr/RemoteNub/<RNUBLIBRARY>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/get-library-version (object :: Rtmgr/<RemoteNub>, dll :: Rtmgr/RemoteNub/<RNUBLIBRARY>)
 => (maj :: Rtmgr/RemoteNub/<NUBINT>, min :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/get-library-filename (object :: Rtmgr/<RemoteNub>, dll :: Rtmgr/RemoteNub/<RNUBLIBRARY>)
 => (result :: CORBA/<string>);

define open generic Rtmgr/RemoteNub/get-library-undecorated-name (object :: Rtmgr/<RemoteNub>, dll :: Rtmgr/RemoteNub/<RNUBLIBRARY>)
 => (result :: CORBA/<string>);

define open generic Rtmgr/RemoteNub/get-register-name (object :: Rtmgr/<RemoteNub>, reg :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: CORBA/<string>);

define open generic Rtmgr/RemoteNub/get-register-enumeration-code (object :: Rtmgr/<RemoteNub>, reg :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/all-registers (object :: Rtmgr/<RemoteNub>)
 => (first :: Rtmgr/RemoteNub/<NUBINT>, last :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/general-registers (object :: Rtmgr/<RemoteNub>)
 => (first :: Rtmgr/RemoteNub/<NUBINT>, last :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/special-registers (object :: Rtmgr/<RemoteNub>)
 => (first :: Rtmgr/RemoteNub/<NUBINT>, last :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/floating-registers (object :: Rtmgr/<RemoteNub>)
 => (first :: Rtmgr/RemoteNub/<NUBINT>, last :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/page-read-permission (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/page-write-permission (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/page-relative-address (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>, offset :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/virtual-page-size (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/read-value-from-process-memory (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/write-value-to-process-memory (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, val :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (status :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/calculate-stack-address (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, offset :: Rtmgr/RemoteNub/<NUBINT>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/target-address-to-string (object :: Rtmgr/<RemoteNub>, x :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, sz :: Rtmgr/RemoteNub/<NUBINT>, radix :: Rtmgr/RemoteNub/<NUBINT>, pad :: Rtmgr/RemoteNub/<NUBINT>)
 => (result :: CORBA/<string>, truncated :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/string-to-target-address (object :: Rtmgr/<RemoteNub>, sz :: Rtmgr/RemoteNub/<NUBINT>, buffer :: CORBA/<string>, radix :: Rtmgr/RemoteNub/<NUBINT>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, overflow :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/read-single-float-from-process-memory (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUBFLOAT>, status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/write-single-float-to-process-memory (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, value :: Rtmgr/RemoteNub/<NUBFLOAT>)
 => (status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/read-double-float-from-process-memory (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUBDOUBLE>, status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/write-double-float-to-process-memory (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, value :: Rtmgr/RemoteNub/<NUBDOUBLE>)
 => (status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/read-byte-string-from-process-memory (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, sz :: Rtmgr/RemoteNub/<NUBINT>)
 => (buffer :: CORBA/<string>, status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/write-byte-string-to-process-memory (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, sz :: Rtmgr/RemoteNub/<NUBINT>, buffer :: CORBA/<string>)
 => (status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/read-value-from-process-register-in-stack-frame (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, reg :: Rtmgr/RemoteNub/<NUB-INDEX>, frame-index :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/read-value-from-process-register (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, reg :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/write-value-to-process-register (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, reg :: Rtmgr/RemoteNub/<NUB-INDEX>, value :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/read-single-float-from-process-register (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, reg :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<NUBFLOAT>, status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/write-single-float-to-process-register (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, reg :: Rtmgr/RemoteNub/<NUB-INDEX>, value :: Rtmgr/RemoteNub/<NUBFLOAT>)
 => (status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/read-double-float-from-process-register (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, reg :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<NUBDOUBLE>, status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/write-double-float-to-process-register (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, reg :: Rtmgr/RemoteNub/<NUB-INDEX>, value :: Rtmgr/RemoteNub/<NUBDOUBLE>)
 => (status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/application-restart (object :: Rtmgr/<RemoteNub>)
 => ();

define open generic Rtmgr/RemoteNub/application-stop (object :: Rtmgr/<RemoteNub>)
 => ();

define open generic Rtmgr/RemoteNub/application-continue (object :: Rtmgr/<RemoteNub>)
 => ();

define open generic Rtmgr/RemoteNub/application-continue-unhandled (object :: Rtmgr/<RemoteNub>)
 => ();

define open generic Rtmgr/RemoteNub/application-step (object :: Rtmgr/<RemoteNub>, n :: Rtmgr/RemoteNub/<NUBINT>)
 => ();

define open generic Rtmgr/RemoteNub/application-step-over (object :: Rtmgr/<RemoteNub>, n :: Rtmgr/RemoteNub/<NUBINT>)
 => ();

define open generic Rtmgr/RemoteNub/application-step-out (object :: Rtmgr/<RemoteNub>)
 => ();

define open generic Rtmgr/RemoteNub/set-stepping-control-on-thread (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, fp :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, calling-fp :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, location-count :: Rtmgr/RemoteNub/<NUBINT>, locs :: Rtmgr/RemoteNub/<RTARGET-ADDRESS-SEQ>, operation :: Rtmgr/RemoteNub/<NUBINT>)
 => (result :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/clear-stepping-control-on-thread (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => ();

define open generic Rtmgr/RemoteNub/thread-stop (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => ();

define open generic Rtmgr/RemoteNub/thread-continue (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => ();

define open generic Rtmgr/RemoteNub/thread-suspendedQ (object :: Rtmgr/<RemoteNub>, thread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/thread-suspended (object :: Rtmgr/<RemoteNub>, thread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => ();

define open generic Rtmgr/RemoteNub/thread-resumed (object :: Rtmgr/<RemoteNub>, thread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => ();

define open generic Rtmgr/RemoteNub/kill-application (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/close-application (object :: Rtmgr/<RemoteNub>)
 => ();

define open generic Rtmgr/RemoteNub/close-remote-tether (object :: Rtmgr/<RemoteNub>)
 => ();

define open generic Rtmgr/RemoteNub/setup-function-call (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, func :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, arg-count :: Rtmgr/RemoteNub/<NUBINT>, args :: Rtmgr/RemoteNub/<RTARGET-ADDRESS-SEQ>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, cx-handle :: Rtmgr/RemoteNub/<RNUBHANDLE>);

define open generic Rtmgr/RemoteNub/remote-call-spy (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, func :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, arg-count :: Rtmgr/RemoteNub/<NUBINT>, args :: Rtmgr/RemoteNub/<RTARGET-ADDRESS-SEQ>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, status :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/get-function-result (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/restore-context (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, the-context :: Rtmgr/RemoteNub/<RNUBHANDLE>)
 => ();

define open generic Rtmgr/RemoteNub/set-breakpoint (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/clear-breakpoint (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUB-ERROR>);

define open generic Rtmgr/RemoteNub/query-breakpoint (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/wait-for-stop-reason-with-timeout (object :: Rtmgr/<RemoteNub>, timeout :: Rtmgr/RemoteNub/<NUBINT>)
 => (code :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/profile-wait-for-stop-reason-with-timeout (object :: Rtmgr/<RemoteNub>, timeout :: Rtmgr/RemoteNub/<NUBINT>, profiling-interval :: Rtmgr/RemoteNub/<NUBINT>)
 => (code :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/inform-profiling-started (object :: Rtmgr/<RemoteNub>)
 => ();

define open generic Rtmgr/RemoteNub/inform-profiling-stopped (object :: Rtmgr/<RemoteNub>)
 => ();

define open generic Rtmgr/RemoteNub/can-receive-first-chance (object :: Rtmgr/<RemoteNub>, ecode :: Rtmgr/RemoteNub/<NUBINT>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/set-first-chance (object :: Rtmgr/<RemoteNub>, ecode :: Rtmgr/RemoteNub/<NUBINT>)
 => ();

define open generic Rtmgr/RemoteNub/unset-first-chance (object :: Rtmgr/<RemoteNub>, ecode :: Rtmgr/RemoteNub/<NUBINT>)
 => ();

define open generic Rtmgr/RemoteNub/thread-stop-information (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>, fchance :: Rtmgr/RemoteNub/<NUBINT>, fstart :: Rtmgr/RemoteNub/<NUBINT>, ret-addr :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/wait-for-stop-reason-no-timeout (object :: Rtmgr/<RemoteNub>)
 => (ecode :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/profile-wait-for-stop-reason-no-timeout (object :: Rtmgr/<RemoteNub>, profile-interval :: Rtmgr/RemoteNub/<NUBINT>)
 => (ecode :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/stop-reason-process (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<RNUB>);

define open generic Rtmgr/RemoteNub/stop-reason-thread (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<RNUBTHREAD>);

define open generic Rtmgr/RemoteNub/first-hard-coded-breakpoint (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/stop-reason-process-exit-code (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/stop-reason-thread-exit-code (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/stop-reason-library (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<RNUBLIBRARY>);

define open generic Rtmgr/RemoteNub/stop-reason-violation-op (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/exception-first-chance (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/stop-reason-violation-address (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/stop-reason-exception-address (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/stop-reason-debug-string-address (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/stop-reason-debug-string-length (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/stop-reason-debug-string-is-unicode (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/initialize-stack-vectors (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/read-stack-vectors (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>, frame-count :: Rtmgr/RemoteNub/<NUBINT>)
 => (frame-pointers :: Rtmgr/RemoteNub/<RTARGET-ADDRESS-SEQ>, instruction-pointers :: Rtmgr/RemoteNub/<RTARGET-ADDRESS-SEQ>, return-addresses :: Rtmgr/RemoteNub/<RTARGET-ADDRESS-SEQ>);

define open generic Rtmgr/RemoteNub/all-frame-lexicals (object :: Rtmgr/<RemoteNub>, frame :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, ip :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (first :: Rtmgr/RemoteNub/<NUB-INDEX>, last :: Rtmgr/RemoteNub/<NUB-INDEX>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>);

define open generic Rtmgr/RemoteNub/register-interactive-code-segment (object :: Rtmgr/<RemoteNub>, lo :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, hi :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => ();

define open generic Rtmgr/RemoteNub/get-lexical-variable-name (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>, variable :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: CORBA/<string>);

define open generic Rtmgr/RemoteNub/lexical-variable-address (object :: Rtmgr/<RemoteNub>, fp :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>, variable :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, in-reg :: Rtmgr/RemoteNub/<NUBINT>, hireg :: Rtmgr/RemoteNub/<NUB-INDEX>, loreg :: Rtmgr/RemoteNub/<NUB-INDEX>, arg :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/lookup-symbol-name (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>, sym :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: CORBA/<string>);

define open generic Rtmgr/RemoteNub/lookup-symbol-address (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>, sym :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/lookup-function-debug-start (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>, sym :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/lookup-function-debug-end (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>, sym :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/lookup-symbol-language (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>, sym :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/lookup-function-end (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>, sym :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/symbol-is-function (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>, sym :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/nearest-symbols (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>, lib :: Rtmgr/RemoteNub/<RNUBLIBRARY>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>);

define open generic Rtmgr/RemoteNub/closest-symbol (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>, lib :: Rtmgr/RemoteNub/<RNUBLIBRARY>, actual-address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, offset :: Rtmgr/RemoteNub/<NUBINT>, name-length :: Rtmgr/RemoteNub/<NUBINT>, type :: Rtmgr/RemoteNub/<NUBINT>, is-function :: Rtmgr/RemoteNub/<NUBINT>, debug-start :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, debug-end :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, language :: Rtmgr/RemoteNub/<NUBINT>, final-address-of-definition :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/function-bounding-addresses (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (lower :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, upper :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/closest-symbol-name (object :: Rtmgr/<RemoteNub>, sz :: Rtmgr/RemoteNub/<NUBINT>)
 => (result :: CORBA/<string>);

define open generic Rtmgr/RemoteNub/find-symbol-in-library (object :: Rtmgr/<RemoteNub>, nublibrary :: Rtmgr/RemoteNub/<RNUBLIBRARY>, sz :: Rtmgr/RemoteNub/<NUBINT>, name :: CORBA/<string>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, type :: Rtmgr/RemoteNub/<NUBINT>, is-function :: Rtmgr/RemoteNub/<NUBINT>, debug-start :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, debug-end :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, symbol-language :: Rtmgr/RemoteNub/<NUBINT>, final-address-of-definition :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/dispose-lookups (object :: Rtmgr/<RemoteNub>, lookups :: Rtmgr/RemoteNub/<RNUBHANDLE>)
 => ();

define open generic Rtmgr/RemoteNub/resolve-source-location (object :: Rtmgr/<RemoteNub>, nublibrary :: Rtmgr/RemoteNub/<RNUBLIBRARY>, filename :: CORBA/<string>, line-number :: Rtmgr/RemoteNub/<NUBINT>, column-number :: Rtmgr/RemoteNub/<NUBINT>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, valid :: Rtmgr/RemoteNub/<NUBINT>, path :: Rtmgr/RemoteNub/<NUBINT>, search :: Rtmgr/RemoteNub/<RNUBHANDLE>, exact :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/fetch-source-locations (object :: Rtmgr/<RemoteNub>, start-loc :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, end-loc :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<RNUBHANDLE>);

define open generic Rtmgr/RemoteNub/source-location-address (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>, index :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/source-location-linenumber (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>, index :: Rtmgr/RemoteNub/<NUB-INDEX>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/source-location-filename (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>)
 => (result :: CORBA/<string>);

define open generic Rtmgr/RemoteNub/number-of-source-locations (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/dispose-source-locations (object :: Rtmgr/<RemoteNub>, table :: Rtmgr/RemoteNub/<RNUBHANDLE>)
 => ();

define open generic Rtmgr/RemoteNub/interpret-instruction-at-current-location (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => (flow :: Rtmgr/RemoteNub/<NUBINT>, destination :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, instruction-size :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/dylan-calculate-step-into (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, function-register-live :: Rtmgr/RemoteNub/<NUBINT>, ok :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/dylan-thread-environment-block-address (object :: Rtmgr/<RemoteNub>, thread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, valid :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/dylan-thread-mv-buffer-live (object :: Rtmgr/<RemoteNub>, thread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/older-stack-frame (object :: Rtmgr/<RemoteNub>, this-one :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, than-this-one :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/dylan-current-function (object :: Rtmgr/<RemoteNub>, nubthread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => (result :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>);

define open generic Rtmgr/RemoteNub/perform-absolute-relocation (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, destination :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/perform-relative-relocation (object :: Rtmgr/<RemoteNub>, address :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>, destination :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/recover-breakpoint (object :: Rtmgr/<RemoteNub>, thread :: Rtmgr/RemoteNub/<RNUBTHREAD>)
 => ();

define open generic Rtmgr/RemoteNub/get-process-wall-clock-time (object :: Rtmgr/<RemoteNub>)
 => (result :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/register-exit-process-function (object :: Rtmgr/<RemoteNub>, ExitProcess :: Rtmgr/RemoteNub/<RTARGET-ADDRESS>)
 => ();

define open generic Rtmgr/RemoteNub/open-local-tether (object :: Rtmgr/<RemoteNub>, command :: CORBA/<string>, args :: CORBA/<string>, paths :: Rtmgr/RemoteNub/<STRING-SEQ>, lib-paths :: Rtmgr/RemoteNub/<STRING-SEQ>, working-directory :: CORBA/<string>, create-shell :: Rtmgr/RemoteNub/<NUBINT>)
 => (result :: Rtmgr/RemoteNub/<RNUB>, success :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/attach-local-tether (object :: Rtmgr/<RemoteNub>, process :: Rtmgr/RemoteNub/<RNUBPROCESS>, process-name :: CORBA/<string>, process-system-id :: CORBA/<string>, process-actual-id :: Rtmgr/RemoteNub/<RNUB>, symbol-paths :: Rtmgr/RemoteNub/<STRING-SEQ>, system-JIT-information :: CORBA/<string>)
 => (result :: Rtmgr/RemoteNub/<RNUB>, success :: Rtmgr/RemoteNub/<NUBINT>);

define open generic Rtmgr/RemoteNub/OpenNub (object :: Rtmgr/<RemoteNub>, access-path :: Rtmgr/<AccessPath>)
 => ();

define open generic Rtmgr/RemoteNub/CloseNub (object :: Rtmgr/<RemoteNub>)
 => ();

define open abstract class Rtmgr/<NubServer> (<object>)
end class;

define method class-typecode (class :: subclass(Rtmgr/<NubServer>))
 => (typecode :: <object-reference-typecode>)
  Rtmgr/$NubServer-typecode;
end method;

define method object-typecode (object :: Rtmgr/<NubServer>)
 => (typecode :: <object-reference-typecode>)
  Rtmgr/$NubServer-typecode;
end method;

define constant Rtmgr/$NubServer-typecode = make(<object-reference-typecode>, type: Rtmgr/<NubServer>, name: "NubServer", repository-id: "IDL:functionalobjects.com/Rtmgr/NubServer:1.0");

define constant Rtmgr/NubServer/<NUBINT> = CORBA/<long>;

define constant Rtmgr/NubServer/<NUB-INDEX> = CORBA/<long>;

define constant Rtmgr/NubServer/<RNUB> = CORBA/<unsigned-long>;

define constant Rtmgr/NubServer/<RNUBPROCESS> = CORBA/<unsigned-long>;

define constant Rtmgr/NubServer/<RemoteNub-SEQ> = limited(CORBA/<sequence>, of: Rtmgr/<RemoteNub>);

define open generic Rtmgr/NubServer/nubs (object :: Rtmgr/<NubServer>)
 => (result :: Rtmgr/NubServer/<RemoteNub-SEQ>);

define open generic Rtmgr/NubServer/CreateNub (object :: Rtmgr/<NubServer>, process-name :: CORBA/<string>, remote-machine :: CORBA/<string>)
 => (result :: Rtmgr/<RemoteNub>);

define open generic Rtmgr/NubServer/DestroyNub (object :: Rtmgr/<NubServer>, nub :: Rtmgr/<RemoteNub>)
 => ();

define open generic Rtmgr/NubServer/RegisterNub (object :: Rtmgr/<NubServer>, nub :: Rtmgr/<RemoteNub>, process-name :: CORBA/<string>, process-id :: CORBA/<string>, remote-machine :: CORBA/<string>)
 => ();

define open generic Rtmgr/NubServer/DeregisterNub (object :: Rtmgr/<NubServer>, nub :: Rtmgr/<RemoteNub>)
 => ();

define open generic Rtmgr/NubServer/ShutdownServer (object :: Rtmgr/<NubServer>)
 => ();

define open generic Rtmgr/NubServer/get-local-hostname (object :: Rtmgr/<NubServer>)
 => (result :: CORBA/<string>);

define open generic Rtmgr/NubServer/verify-local-password (object :: Rtmgr/<NubServer>, password :: CORBA/<string>, remote-machine :: CORBA/<string>)
 => (result :: Rtmgr/NubServer/<NUBINT>);

define open generic Rtmgr/NubServer/update-local-process-list (object :: Rtmgr/<NubServer>)
 => (result :: Rtmgr/NubServer/<NUBINT>);

define open generic Rtmgr/NubServer/local-process-nub-descriptor (object :: Rtmgr/<NubServer>, i :: Rtmgr/NubServer/<NUB-INDEX>)
 => (result :: Rtmgr/NubServer/<RNUBPROCESS>);

define open generic Rtmgr/NubServer/local-process-identifier (object :: Rtmgr/<NubServer>, nubprocess :: Rtmgr/NubServer/<RNUBPROCESS>)
 => (result :: Rtmgr/NubServer/<NUBINT>);

define open generic Rtmgr/NubServer/local-process-name (object :: Rtmgr/<NubServer>, i :: Rtmgr/NubServer/<NUB-INDEX>)
 => (result :: CORBA/<string>);

define open generic Rtmgr/NubServer/local-process-system-identifier (object :: Rtmgr/<NubServer>, i :: Rtmgr/NubServer/<NUB-INDEX>)
 => (result :: CORBA/<string>);

define open generic Rtmgr/NubServer/local-process-actual-identifier (object :: Rtmgr/<NubServer>, i :: Rtmgr/NubServer/<NUB-INDEX>)
 => (result :: Rtmgr/NubServer/<RNUB>);


/* eof */
